
;******************************************************************
;*                                                                *
;* A Windows Screen Capture Utility based on MicroSoft's Wincap,  *
;* v3.10 2nd Edition                                              *
;*                                                                *
;* Converted from "C" into a Win32asm app by Ron Thomas Aug/2002  *
;*                                                                *
;******************************************************************
;*                                                                *
;* Oct. 5th  - Can capture DESKTOP to screen                      *
;*           - Can save this to as a bitmap                       *
;*           - Can now Print (Sept)                               *
;* Oct. 6th  - Rectangle capture works                            *
;* Oct. 9th  - "Window" capture  works                            *
;*           - also, Active Window and Client Area                *
;*                                                                *
;* Oct. 13th - Oct Capture to clipboard  now OK                   *
;* Oct. 16th - Oct Help Added                                     *
;*                                                                *
;* Bugs:                                                          *
;* Print problem:                                                 *
;*   An image will only currently print if it has been captured   *
;*   In "Desktop" mode; We need to be able to print in all modes. *
;*                                                                *
;* To Do or try:                                                  *
;*     Setup Smart keys for capture                               *
;*     Save images alternately in jpg for smaller file size       *
;*     Provide a movie mode capture in a sequence of jpg files    *
;*                                                                *
;******************************************************************
;
        .486                            ; 32 bit when .386 or higher appears before .model
        .model  flat, stdcall
        option  casemap :none
;
; Includes
;---------------------------------------
        include     \masm32\include\windows.inc
        include     \masm32\include\user32.inc
        include     \masm32\include\kernel32.inc
        include     \masm32\include\gdi32.inc
        include     \masm32\include\comdlg32.inc
        include     DibAPI32.inc
;
; Libraries
;---------------------------------------
        includelib  \masm32\lib\user32.lib
        includelib  \masm32\lib\kernel32.lib
        includelib  \masm32\lib\gdi32.lib
        includelib  \masm32\lib\comdlg32.lib
        includelib  DibAPI32.lib        ; Use DIB functions within DibApi
;
; Prototypes
;---------------------------------------
WinMain             PROTO  :DWORD, :DWORD, :DWORD, :SDWORD
AboutDlgProc        PROTO  :DWORD, :DWORD, :DWORD, :DWORD
CenterWindow        PROTO  :DWORD, :DWORD
DoCapture           PROTO  :DWORD, :DWORD, :DWORD, :DWORD
DoPaint             PROTO  :DWORD
DoScroll            PROTO  :DWORD, :DWORD, :DWORD, :DWORD
DoSize              PROTO  :DWORD
DrawSelect          PROTO  :DWORD, :DWORD
FileSaveHookProc    PROTO  :DWORD, :DWORD, :DWORD, :DWORD
FrameWindow         PROTO  :DWORD
FullViewWndProc     PROTO  :DWORD, :DWORD, :DWORD, :DWORD
GetFileName         PROTO  :DWORD, :DWORD, :DWORD
NormalizeRect       PROTO  :DWORD
PrintDlgProc        PROTO  :DWORD, :DWORD, :DWORD, :DWORD
PrintSetup          PROTO  :DWORD, :DWORD
ReallyGetClientRect PROTO  :DWORD,:DWORD
RectangleDlgProc    PROTO  :DWORD, :DWORD, :DWORD, :DWORD
RubberBandScreen    PROTO  :DWORD, :DWORD
SaveBmp             PROTO
SavingDlg           PROTO  :DWORD, :DWORD, :DWORD, :DWORD
SelectDlgProc       PROTO  :DWORD, :DWORD, :DWORD, :DWORD
SetupScrollBars     PROTO  :DWORD, :DWORD, :DWORD
;
.const
;---------------------------------------
SCROLL_RATIO        equ     4
WM_DOCAPTURE        equ     WM_USER+101 ; Used for screen capture messages

IDC_FILETEXT        equ     104
IDC_BESTFIT         equ     119
IDC_STRETCHTOPAGE   equ     120
IDC_SCALE           equ     121
IDC_XAXIS           equ     122
IDC_XTEXT           equ     200
IDC_YAXIS           equ     201
IDC_YTEXT           equ     202
IDC_PRINTTEXT1      equ     401
IDC_PRINTTEXT2      equ     402
IDC_PERCENTAGE      equ     403
IDC_TEXT1           equ     525
IDC_STATIC_RECT2    equ     1002
IDC_STATIC_RECT3    equ     1003
IDC_STATIC_SELECT2  equ     1004
IDC_STATIC_SELECT3  equ     1005
IDD_FILETYPE        equ     101
IDD_RGB             equ     102
IDD_RLE4            equ     103
IDD_RLE8            equ     104
IDD_1               equ     106
IDD_4               equ     107
IDD_8               equ     108
IDD_24              equ     109
IDD_FILETYPEGROUP   equ     110
;
IDM_SAVE            equ     110
IDM_PRINT           equ     120
IDM_EXIT            equ     130
IDM_ABOUT           equ     140
IDM_EDITCOPY        equ     180
IDM_CAPTWINDOW      equ     210
IDM_CAPTCLIENT      equ     220
IDM_CAPTRECT        equ     230
IDM_CAPTUREHIDE     equ     240
IDM_ACTIVEWINDOW    equ     250
IDM_DESKTOP         equ     260
IDM_VIEWFULL        equ     310
IDM_VIEWRESTORED    equ     320
IDM_VIEWCLEAR       equ     330
IDM_CURSORSELECT    equ     340
IDM_SELECTRECT      equ     350
IDM_HELP            equ     400
;
IDS_SAVEASTITLE     equ     1
IDS_RECT2           equ     2
IDS_RECT3           equ     3
IDS_SELECT2         equ     5
IDS_SELECT3         equ     6
;
PW_BESTFIT          equ     1
PW_STRETCHTOPAGE    equ     2
PW_SCALE            equ     3
PW_WINDOW           equ     1
PW_CLIENT           equ     2
;
MAXFILENAMELEN      equ     144
PALVERSION          equ     0300h
;
; For PrintBmp
;---------------------------------------
SHOW_NORMAL         equ     1           ; Actual size
SHOW_CENTRE         equ     2           ; Image is centred
SHOW_STRETCH        equ     3           ; Stretch to Window
SHOW_ISOSTRETCH     equ     4           ; Stretch Isotropically

;
; Structures
;---------------------------------------
POPTIONS            STRUCT              ; Print Options
  iOption           DWORD   ?
  iXScale           DWORD   ?           ; If iOptions is DLGPRINT_SCALE
  iYScale           DWORD   ?
POPTIONS            ENDS
;
.data
;---------------------------------------
opts                POPTIONS <>
rScreen             RECT    <>
rRubberBand         RECT    <>
pt                  POINT   <>
bStartup            dd      TRUE
bViewFull           dd      FALSE
ghBitmap            dd      0
ghPal               dd      0
gbLButtonDown       dd      FALSE
gbSave              dd      FALSE
ghWndCapture        dd      0
gbNowCapturing      dd      0
gbCaptRect          dd      FALSE
bCapturedYet        dd      FALSE
bSizing             dd      FALSE
ghAboutBmp          dd      FALSE
hSelectDlg          dd      0
hPal                dd      0
szScreenCap         db      'Screen Capture', 0
szWCRunning         db      'WinCapture is already running.  Multiple copies of WinCapture not allowed', 0
szSTARTBMP          db      'STARTBMP', 0
szAbout             db      "ABOUT", 0
szSelect            db      "SELECT", 0
szDisplay           db      "DISPLAY", 0
szRectangle         db      "RECTANGLE", 0
szViewFS            db      "View Fullscreen", 0
szMAINMENU          db      "MAINMENU", 0
szNoimage           db      "No Image", 0
AlreadyCap          db      "Already captured", 0
Want2Sav            db      "Want to save", 0
szSavebitmap        db      "Save bitmap", 0
szABOUTBMP          db      "ABOUTBMP", 0
szFILESAVE          db      "FILESAVE", 0
szCantCapt          db      "Cannot capture that window", 0
szNotVisible        db      "Window isn't visible - can't capture", 0
szInternalErr       db      "Internal Error: Invalid command", 0
szEntireScreen      db      "Entire Screen", 0
szUserPortion       db      "User selected portion", 0
szAppName           db      'WinCapture', 0
ViewClass           db      "View Class", 0
gszWindowText       db      100 DUP (?), 0
szSaving            db      "SAVING", 0
szSaveError         db      "Save DIB error", 0
szCantSave          db      "Can't save bitmap", 0
StarDotBMP          db      "*.BMP", 0
szFilter            db      "Bitmap Files (*.bmp)", 0, "*.bmp", 0,\
                            "All Files (*.*)", 0, "*.*", 0, 0
szBMP               db      "bmp", 0
szTitle             db      50 DUP (?),0
szHelp              db      "WinCapture.hlp", 0  ; Help File
;
.data?
;---------------------------------------
ALIGN 4
CommandLine         LPSTR   ?
hInstance           dd      ?
static              dd      ?
ghInst              dd      ?           ; Handle to instance
ghInst2             dd      ?           ; Handle to instance
lpofn               dd      ?           ; Save pointer for FileSaveHookProc
maxX                dd      ?
maxY                dd      ?
memDC               dd      ?
hBit                dd      ?
hBit2               dd      ?
hModelessDlg        dd      ?           ; Handle to modeless "Saving to file..." dialog box
ghbmLogo            dd      ?           ; Handle to logo bitmap
hRectangleDlg       dd      ?           ; help dialog for rectangle selection
ghWnd               dd      ?           ; Handle to main window
hOldCursor          dd      ?
hBrowseWnd          dd      ?
dwFlags             dd      ?
hDlgAbort           dd      ?           ; Handle For PrintDIB
hAccel              dd      ?
mDC                 dd      ?           ; Memory device context
wCaptureCommand     WORD    ?
szFileBuff          db      255 DUP (?)
szFile              db      [MAXFILENAMELEN] DUP (?)    ; File name
;
;Macros
;---------------------------------------
WIDTHBYTES  MACRO arg
; Perform DWORD-aligning of DIB scanlines, multiplying
; the bit count for the scanline (biWidth * biBitCount),
; and returns the number of DWORD-aligned bytes needed
; to hold those bits. ((bits) + 31) / 32 * 4)
        mov     eax, arg
        add     eax, 31                 ; Round up to next dword
        shr     eax, 3                  ; divide by 8 to get # bytes
        ENDM

RECTWIDTH   MACRO arg
        push    ebx
        mov     arg, ebx
        mov     eax, RECT.right[ebx]
        sub     eax, RECT.left[ebx]
        pop     ebx
        ENDM

RECTHEIGHT  MACRO arg
        push    ebx
        mov     arg, ebx
        mov     eax, RECT.bottom[ebx]
        sub     eax, RECT.top[ebx]
        pop     ebx
        ENDM

LOWORD  MACRO   bigword                 ;; Retrieves the low word from double word argument
        mov     eax, bigword
        and     eax, 0FFFFh             ;; Set to low word
        ENDM

HIWORD  MACRO   bigword                 ;; Retrieves the high word from double word
        mov     eax, bigword
        shr     eax, 16                 ;; Shift 16 for high word to set to high word
        ENDM

MAX     MACRO   word1, word2            ;; Return the maximum of 2 integers in eax
        mov     eax, word1
        .if eax < word2
          mov     eax, word2            ;; Set word2 as max
        .endif
        ENDM

MIN     MACRO   word1, word2            ;; Return the minimum of 2 integers in eax
        mov     eax, word1
        .if eax > word2
          mov     eax, word2            ;; Set word2 as min
        .endif
        ENDM

M2M     MACRO   M1, M2                  ;; Copy word from memory to memory
        push    M2
        pop     M1
        ENDM

RGB     MACRO   red, green, blue        ;; Get composite number from red green and blue bytes
        mov     al, blue                ;; ,,,blue
        shl     eax, 8                  ;; ,,blue,
        add     al, green               ;; ,,blue,green
        shl     eax, 8                  ;; ,blue,green,
        add     al, red                 ;; ,blue,green,red
        and     eax, 0FFFFFFh           ;; Mask out top byte to complete COLORREF dword
        ENDM

return  MACRO   arg
        mov     eax, arg
        ret
        ENDM

CTEXT   macro   Text
        local   szText

        .data
        szText  byte Text, 0
        .code
        exitm   <offset szText>
        ENDM
;
;
.Code
;---------------------------------------
Start:  invoke  GetModuleHandle, NULL
        mov     hInstance, eax
        invoke  GetCommandLine
        invoke  WinMain, hInstance, NULL, CommandLine, SW_SHOWDEFAULT
        invoke  ExitProcess, eax
;
;
WinMain PROC    hInst:HINSTANCE, hPrevInst:HINSTANCE, lpszCmdLine:LPSTR, nCmdShow:SDWORD
;---------------------------------------
        LOCAL   hWnd:HWND, msg:MSG, wc:WNDCLASS
;
        mov     hModelessDlg, NULL      ; Set handle to modeless dialog to NULL
                                        ; because we haven't created it yet
        mov     hRectangleDlg, 0
        invoke  FindWindow, ADDR szAppName, ADDR szScreenCap
        .if  !eax
          mov     wc.style, 0
          mov     wc.lpfnWndProc, offset WndProc
          mov     wc.cbClsExtra, 0
          mov     wc.cbWndExtra, 0
          M2M     wc.hInstance, hInst
          invoke  LoadIcon, hInst, ADDR szAppName
          mov     wc.hIcon, 0
          invoke  LoadCursor, 0, IDC_ARROW
          mov     wc.hCursor, eax
          invoke  GetStockObject, GRAY_BRUSH
          mov     wc.hbrBackground, eax     ; Use black for background for better contrast
          M2M     wc.lpszMenuName, offset szMAINMENU
          M2M     wc.lpszClassName, offset szAppName;
          invoke  RegisterClass, ADDR wc
          .if  !eax
            return FALSE
          .endif
          M2M     ghInst2,hInst         ; Set Global variable
;         Create a main window for this application instance.
          invoke  CreateWindowEx, NULL, ADDR szAppName, ADDR szScreenCap, WS_OVERLAPPEDWINDOW,
                  CW_USEDEFAULT, CW_USEDEFAULT, 450, 345, NULL, NULL, hInstance, NULL
          mov     hWnd, eax
          mov     ghWnd, eax            ; Set global variable
          invoke  ShowWindow, hWnd, nCmdShow
          invoke  UpdateWindow, hWnd
;         Create our full-screen view class
          mov     wc.style, 0
          M2M     wc.lpfnWndProc, offset FullViewWndProc
          mov     wc.cbClsExtra, 0
          mov     wc.cbWndExtra, 0
          M2M     wc.hInstance, hInst
          mov     wc.hIcon, NULL
          invoke  LoadCursor, NULL, IDC_ARROW
          mov     wc.hCursor, eax
          invoke  GetStockObject, GRAY_BRUSH
          mov     wc.hbrBackground, eax
          mov     wc.lpszMenuName, 0
          mov     wc.lpszClassName, offset ViewClass
          invoke  RegisterClass, ADDR wc
          .if !eax
            return FALSE
         .endif
         ;---------------------------------------;
         ; Let's make this a single-instance app ;
         ; -- we can get into hotkey conflicts   ;
         ; e.g. windows won't know which instance;
         ; of WinCapture to send the message to. ;
         ;---------------------------------------;
        .else
          invoke  MessageBeep, 0
          invoke  MessageBox, 0, ADDR szWCRunning, ADDR szAppName, MB_OK or MB_ICONHAND
          return  FALSE
        .endif
;        ;---------------------------------------;
;        ; Polling messages from event queue --  ;
;        ; we have a modeless dialog box, so we  ;
;        ; have to take care of them here, also. ;
;        ;---------------------------------------;
        .while TRUE
          invoke  GetMessage, ADDR msg, NULL, 0, 0
          .break  .if !eax
          invoke  IsDialogMessage, hModelessDlg, ADDR msg
          push    eax
          invoke  IsDialogMessage, hSelectDlg, ADDR msg
          push    eax
          invoke  IsDialogMessage, hRectangleDlg, ADDR msg
          pop     ecx
          pop     edx
          .if hModelessDlg==0  || !edx || hSelectDlg \
                               || !ecx || hRectangleDlg || !eax
            invoke  TranslateMessage, ADDR msg
            invoke  DispatchMessage, ADDR msg
          .endif
        .endw
        return  msg.wParam;
;---------------------------------------
WinMain ENDP
;
;
;---------------------------------------;
; WndProc:                              ;
;                                       ;
; Main window procedure.  It receives   ;
; all the messages destined for the     ;
; application's main window.  When we   ;
; capture a window, we capture it into  ;
; a Device-Dependent bitmap,  At the    ;
; same time, we get a copy of the cur-  ;
; rent system palette. This makes dis-  ;
; playing the bitmap on the screen very ;
; fast.  When we want to print or save  ;
; the captured window, we need to use   ;
; this palette to convert DDB to a DIB. ;
;---------------------------------------;
WndProc PROC    hWnd:HWND, wMessage:UINT, wParam:WPARAM, lParam:LPARAM
;---------------------------------------
        LOCAL   pts:POINTS
        LOCAL   hDib:DWORD, wRet:DWORD, hWndCurrent:DWORD
        LOCAL   hViewWnd:DWORD          ; Handle to our view window
        LOCAL   hDC:HDC                 ; Handle to device context
        LOCAL   hOldPal:DWORD           ; Handle to previous logical palette
        LOCAL   ScreenX:DWORD, ScreenY:DWORD
        LOCAL   dCompression:DWORD
        LOCAL   bSuccess:DWORD, cxPage:DWORD, cyPage:DWORD, hdcPrn:DWORD

        ;---------------------------------------;
        ; The gbNowCapturing variable is set to ;
        ; TRUE if we are in the middle of       ;
        ; printing.  This takes care of the     ;
        ; case when the user presses the hotkey ;
        ; during capturing.                     ;
        ;---------------------------------------;
        mov     eax, wMessage
        .if eax==WM_CREATE
          .if !hSelectDlg               ; Setup the Window select dialog and save the handle
            invoke  CreateDialogParam, ghInst2, ADDR szSelect, hWnd, ADDR SelectDlgProc, 0
            mov     hSelectDlg, eax
          .endif
          .if !hRectangleDlg            ; Setup the Rectangle select dialog and save the handle
            invoke   CreateDialogParam, ghInst2, ADDR szRectangle, hWnd, ADDR RectangleDlgProc, 0
            mov      hRectangleDlg, eax
          .endif
;         Get screen coordinates
          invoke  GetSystemMetrics, SM_CXSCREEN
          mov     maxX, eax
          invoke  GetSystemMetrics, SM_CYSCREEN
          mov     maxY, eax
;         Create a virtual window
          invoke  GetDC, hWnd
          mov     hDC, eax
          invoke  CreateCompatibleDC, hDC
          mov     mDC, eax
          invoke  CreateCompatibleBitmap, hDC, maxX, maxY
          mov     hBit, eax
          invoke  SelectObject, mDC, hBit
          invoke  LoadBitmap, ghInst2, ADDR szSTARTBMP
          mov     ghbmLogo, eax
        .elseif eax==WM_INITMENU        ; Gray out menu items if we haven't captured anything yet.
;         "Save", "Print" and "Copy"
          .if bCapturedYet
            mov     ecx, MF_ENABLED
          .else
            mov     ecx, MF_DISABLED or MF_GRAYED
          .endif
          or      ecx, MF_BYCOMMAND
          push    ecx
          invoke  GetMenu, hWnd
          pop     ecx
          invoke  EnableMenuItem, eax, IDM_SAVE, ecx
          .if bCapturedYet
            mov     ecx, MF_ENABLED
          .else
            mov     ecx, MF_DISABLED or MF_GRAYED
          .endif
          or      ecx, MF_BYCOMMAND
          push    ecx
          invoke  GetMenu, hWnd
          pop     ecx
          invoke  EnableMenuItem, eax, IDM_PRINT, ecx
          .if bCapturedYet
            mov     ecx, MF_ENABLED
          .else
            mov     ecx, MF_DISABLED or MF_GRAYED
          .endif
          or      ecx, MF_BYCOMMAND
          push    ecx
          invoke  GetMenu, hWnd
          pop     ecx
          invoke  EnableMenuItem, eax, IDM_EDITCOPY, ecx
          ;---------------------------------------;
          ; The WM_PALETTECHANGED message informs ;
          ; all windows that the window with input;
          ; focus has realized its logical palette;
          ; thereby changing the system palette.  ;
          ; This message allows a window without  ;
          ; input focus that uses a color palette ;
          ; to realize its logical palettes and   ;
          ; update its client area.               ;
          ;                                       ;
          ; This message is sent to all windows,  ;
          ; including the one that changed the    ;
          ; system palette and caused this message;
          ; to be sent. The wParam of this message;
          ; contains the handle of the window that;
          ; caused the system palette to change.  ;
          ; To avoid an infinite loop, care must  ;
          ; be taken to check that the wParam of  ;
          ; this message does not match the       ;
          ; window's handle.                      ;
          ;---------------------------------------;
        .elseif eax==WM_PALETTECHANGED
;         Before processing this message, make sure we are using a palette
          .if ghPal
            ;---------------------------------------;
            ; If this application did not change the;
            ; palette, select and realize this      ;
            ; application's palette.                ;
            ;---------------------------------------;
            mov     eax,hWnd
            .if wParam != eax
;             Need the window's DC for SelectPalette/RealizePalette
              invoke  GetDC, hWnd
              mov     hDC, eax
;             Select and realize our palette
              invoke  SelectPalette, hDC, ghPal, FALSE
              mov     hOldPal, eax
              invoke  RealizePalette, hDC
              ;---------------------------------------;
              ; When updating colors for an inactive  ;
              ; window.  UpdateColors can be called   ;
              ; because it is faster than redrawing   ;
              ; the client area (even though the      ;
              ; results are not as good).             ;
              ;---------------------------------------;
              invoke  UpdateColors, hDC
;             Clean up
              .if hOldPal
                invoke  SelectPalette, hDC, hOldPal, FALSE
              .endif
              invoke  ReleaseDC, hWnd, hDC
            .endif
          .endif
        ;---------------------------------------;
        ; The WM_QUERYNEWPALETTE message informs;
        ; a window that it is about to receive  ;
        ; input focus. In response, the window  ;
        ; receiving focus should realize its    ;
        ; palette as a foreground palette and   ;
        ; update its client area. If the window ;
        ; realizes its palette, it should return;
        ; TRUE, otherwise, should return FALSE. ;
        ;---------------------------------------;
        .elseif eax==WM_QUERYNEWPALETTE
          ; Before processing this message, make sure we are using a palette
          .if ghPal
            invoke  GetDC, hWnd         ; Need window's DC for SelectPalette/RealizePalette
            mov     hDC, eax
            ; Select and realize our palette
            invoke  SelectPalette, hDC, ghPal, FALSE
            mov     hOldPal, eax
            invoke  RealizePalette, hDC
            ; Redraw the entire client area
            invoke  InvalidateRect, hWnd, NULL, TRUE
            invoke  UpdateWindow, hWnd
            ; Clean up
            .if hOldPal
              invoke  SelectPalette, hDC, hOldPal, FALSE
            .endif
            invoke  ReleaseDC, hWnd, hDC
            return  TRUE                ; Message processed, return TRUE
          .endif
        .elseif eax==WM_MOVE
          .if gbNowCapturing
            .if gbCaptRect
              invoke  CenterWindow, hRectangleDlg, hWnd
            .else
              invoke  CenterWindow, hSelectDlg, hWnd
            .endif
          .endif
        .elseif eax==WM_SIZE
          .if gbNowCapturing
            .if gbCaptRect
              invoke  CenterWindow, hRectangleDlg, hWnd
            .else
              invoke  CenterWindow, hSelectDlg, hWnd
            .endif
          .endif
          ; Check if we are already sizing
          .if bSizing
            return  TRUE
          .endif
          mov     bSizing, TRUE
          invoke  DoSize, hWnd
          mov     bSizing, FALSE
        .elseif eax==WM_HSCROLL || eax==WM_VSCROLL
          LOWORD  wParam
          push    eax
          HIWORD  wParam
          pop     ecx
          invoke  DoScroll, hWnd, wMessage, eax, ecx
        .elseif eax==WM_PAINT
          invoke  DoPaint, hWnd
        .elseif eax==WM_COMMAND
          LOWORD  wParam
          .if     eax==IDM_ABOUT
            invoke  DialogBoxParam, ghInst2, ADDR  szAbout, hWnd, ADDR AboutDlgProc, 0
          .elseif eax==IDM_SAVE
            invoke  SaveBmp             ; Save as a file
          .elseif eax==IDM_PRINT        ; Print the bitmap
            invoke  GetSystemPalette
            mov     ghPal, eax          ; ghPal is handle to bitmap palette
            mov     dCompression, BI_RLE4   ; BI_RLE8, BI_RGB - see SaveBmp
            HIWORD  dwFlags             ; Get bit count,
            invoke  ChangeBitmapFormat, ghBitmap, eax, dCompression, ghPal ; Return handle to DIB
            invoke  GlobalLock, eax     ; Return handle to BITMAPINFOHEADER (pbmi)
            mov     ebx, eax
            invoke  PrintBmp, hWnd, hdcPrn, bSuccess, cxPage, cyPage, \
                    ADDR szAppName, eax, SHOW_ISOSTRETCH
          .elseif eax==IDM_VIEWFULL     ; View fullscreen
            .if (!bViewFull && (ghBitmap || bStartup))
              invoke  CreateDC, ADDR szDisplay, NULL, NULL, NULL
              mov     hDC, eax
              invoke  GetDeviceCaps, hDC, HORZRES
              mov     ScreenX, eax
              invoke  GetDeviceCaps, hDC, VERTRES
              mov     ScreenY, eax
              invoke  DeleteDC, hDC
              invoke  CreateWindowEx, 0, ADDR ViewClass, NULL, \
                      WS_POPUP or WS_VISIBLE, 0, 0, ScreenX, ScreenY, \
                      hWnd, NULL, ghInst2, NULL
              mov     hViewWnd, eax
              invoke  ShowWindow, hViewWnd, SW_SHOW
              invoke  UpdateWindow, hViewWnd
            .else
              invoke  MessageBox, hWnd, ADDR szNoimage, ADDR szViewFS, MB_OK
            .endif
          .elseif eax==IDM_EDITCOPY     ; Copy DIB, bitmap, & palette to clipboard
            invoke  OpenClipboard, hWnd
            .if eax
              invoke  EmptyClipboard
              .if ghBitmap
                ; Once these are added to the clipboard, the clipboard owns the data.
                invoke  BitmapToDIB, ghBitmap, ghPal
                mov     hDib, eax
                .if eax
                  invoke  SetClipboardData, CF_DIB, eax
                .endif
                ; Make a copy of the bitmap so the clipboard can own it.
                invoke  DIBToBitmap, hDib, ghPal    ; Return handle in eax
                .if eax
                  invoke  SetClipboardData, CF_BITMAP, eax
                .endif
                ; Make a copy of the palette so the clipboard can own it.
                invoke  GetStockObject, DEFAULT_PALETTE
                .if eax
                  invoke  SetClipboardData, CF_PALETTE, eax
                .endif
              .endif
              invoke  CloseClipboard
            .endif
          .elseif eax==IDM_VIEWCLEAR
            .if gbSave
              invoke  MessageBox, hWnd, ADDR szSavebitmap,ADDR szAppName, \
                      MB_ICONEXCLAMATION or MB_YESNOCANCEL
              mov     wRet, eax
              .if wRet==IDYES
                invoke  SaveBmp
              .endif
            .endif
            mov     gbSave, FALSE
            ; If we are just displaying logo, don't display it anymore.
            .if bStartup
              mov     bStartup, FALSE
            .endif
            ; Delete captured bitmap if we have one
            .if ghBitmap
              invoke  DeleteObject, ghBitmap
              mov     ghBitmap, NULL
            .endif
            ; Delete our captured bitmap's palette if we have one
            .if ghPal
              invoke  DeleteObject, ghPal
              mov     ghPal, NULL
            .endif
            ;---------------------------------------;
            ; Now update display to reflect fact    ;
            ; that we nuked the captured bitmap or  ;
            ; don't want to look at the cool logo.  ;
            ;---------------------------------------;
            invoke  InvalidateRect, hWnd, NULL, TRUE
            invoke  UpdateWindow, hWnd
            mov     bCapturedYet, FALSE ; Gray out "File.Save" menu item
          .elseif eax==IDM_CAPTRECT
            mov     gbCaptRect, TRUE
            jmp     fallthrough1
          .elseif eax==IDM_CAPTWINDOW || eax==IDM_CAPTCLIENT    ; Make sure lParam=IDM_CURSORSELECT
fallthrough1:       mov lParam, IDM_CURSORSELECT
            jmp     fallthrough
          .elseif eax==IDM_ACTIVEWINDOW || eax==IDM_DESKTOP
            ;---------------------------------------;
            ; User selected one of the window cap-  ;
            ; ture items.  Check to see that we are ;
            ; not already in the middle of a cap-   ;
            ; ture.  This could happen if the user  ;
            ; presses our hotkey in the middle of   ;
            ; one of our dialog boxes.              ;
            ;---------------------------------------;
fallthrough:
            .if gbNowCapturing
              invoke  MessageBox, NULL, ADDR AlreadyCap, ADDR szAppName, \
                      MB_OK or MB_ICONEXCLAMATION
            .else
              ;---------------------------------------
              ; User wants to capture screen.  One problem we may
              ; run into here is that we might have a popup menu pulled
              ; down in our own application when we get to this point
              ; (because of the hotkey feature of this app).
              ;
              ; Normally, we'd just enter a message loop after calling
              ; ShowWindow(SW_HIDE) to take care of any menu messages
              ; which may have been posted as we hide our application's
              ; window, and *then* call our screen capture routine.
              ; But unfortunately, we can't do that here and be 100% safe.
              ;
              ; If we *have* been sent here on a hotkey, and a menu of
              ; our own app is currently down, then we are currently running
              ; inside of a PeekMessage loop in the Windows Menu
              ; manager. We should *not* enter another PeekMessage loop,
              ; but should return from this message case right away.
              ; The Windows Menu manager code relies on checking messages
              ; in it's queue via it's own PeekMessage loop, and if we
              ; entered one, it would confuse the menu manager.
              ;
              ; So what we do instead is just post ourselves a private
              ; message, and when we get this message (see below), then
              ; do the screen capture.
              ;
              ; Commence screen capture!
              mov     gbNowCapturing, TRUE
              .if wParam==IDM_DESKTOP
                invoke  ShowWindow, hWnd, SW_HIDE
              .endif
              ; Allow this message case to return right away.  We'll capture screen down below.
              .if lParam != IDM_CURSORSELECT
                ; Send msg to WndProc to process WM_DOCAPTURE
                invoke  PostMessage, hWnd, WM_DOCAPTURE, wParam, 0
              .elseif gbCaptRect
                invoke  CenterWindow, hRectangleDlg, hWnd
                invoke ShowWindow, hRectangleDlg, SW_SHOW
              .else
                invoke  CenterWindow, hSelectDlg, hWnd
                invoke  ShowWindow, hSelectDlg, SW_SHOW
              .endif
              M2M     wCaptureCommand, wParam
            .endif
          .elseif eax==IDM_HELP
            invoke  WinHelp, hWnd, ADDR szHelp, HELP_CONTENTS, 0
          .elseif eax==IDM_EXIT
            invoke  PostMessage, hWnd, WM_CLOSE, 0, 0
          .else
            invoke  DefWindowProc, hWnd, wMessage, wParam, lParam
          .endif
          ; Message case for doing screen capture.  This message is posted
          ; to us from the IDM_CAPT* code above.  wParam should be equal to
          ; the ID of the message which we got sent here for (it is used in
          ; the call to DoCapture).
        .elseif eax==WM_DOCAPTURE
          ; We're going to capture a new screen, get rid of previous captured image
          .if ghBitmap
            invoke  DeleteObject, ghBitmap
            mov     ghBitmap, NULL
          .endif
          .if ghPal
            invoke  DeleteObject, ghPal
            mov     ghPal, NULL
          .endif
          invoke  SetForegroundWindow, ghWndCapture
          ; Save captured screen as bitmap
          invoke  DoCapture, hWnd, wParam, ADDR szAppName, ghWnd
; Gene
            invoke SetForegroundWindow, hWnd

            ; Un-hide Window

            invoke ShowWindow, hWnd, SW_SHOW

        invoke IsIconic, hWnd
           .if eax
                invoke PostMessage, hWnd, WM_SYSCOMMAND, SC_RESTORE, 0
        .endif

           .if !gbCaptRect
                mov gbNowCapturing, FALSE
        .endif

            mov bCapturedYet, TRUE      ; Enable "File.Save" menu item
            mov gbSave, TRUE

        .elseif eax==WM_LBUTTONDOWN

           .if !gbNowCapturing
        jmp skip
            .else

                invoke ShowWindow, hWnd, SW_HIDE     ; Hide main app's window

               .if gbCaptRect
                    invoke ShowWindow, hRectangleDlg, SW_HIDE
                .else
                    invoke ShowWindow, hSelectDlg, SW_HIDE
            .endif

               .if gbCaptRect
                invoke LoadCursor, NULL, IDC_CROSS
            invoke SetCursor, eax
                    mov hOldCursor, eax
                    invoke PostMessage, hWnd, WM_DOCAPTURE, wCaptureCommand, 0

                .else
            invoke LoadCursor, ghInst2, ADDR szSelect
                    invoke SetCursor, eax
            mov hOldCursor, eax
            .endif

                mov gbLButtonDown, TRUE
                invoke SetCapture, ghWnd

            .endif

        .elseif eax==WM_LBUTTONUP

           .if (!(gbNowCapturing && gbLButtonDown))
        jmp skip        ;  if .else .endif probably better
        .endif

            invoke ReleaseCapture
            mov gbLButtonDown, FALSE
            invoke SetCursor, hOldCursor

           .if gbCaptRect
                mov gbCaptRect, FALSE
                mov gbNowCapturing, FALSE
        jmp skip
            .endif

            invoke FrameWindow, hBrowseWnd
            mov hBrowseWnd, NULL

        mov eax, lParam     ; Contains Y in high word, X in low word
        mov pts.x, ax       ; Transfer "x" to Points structure
        shr eax, 16         ; Move high into low word
        mov pts.y, ax       ; Transfer "y"

        mov eax,0           ; Copy structure to structure
        mov ax, pts.x       ;
        mov pt.x, eax       ;
        mov ax, pts.y       ;
        mov pt.y, eax       ;

            ; Convert to screen coordinates

            invoke ClientToScreen, ghWnd, ADDR pt   ; New screen coords copied into pt

            ; Get Window that we clicked on

        invoke WindowFromPoint, pt.x, pt.y      ; ### May be a problem here
        mov ghWndCapture, eax

            ; If it's not a valid window, just return NULL

           .if !ghWndCapture

                invoke SetCursor, hOldCursor
                mov gbLButtonDown,0
            mov gbNowCapturing, 0
                jmp skip
            .endif

            invoke PostMessage, hWnd, WM_DOCAPTURE, wCaptureCommand, 0

        .elseif eax==WM_MOUSEMOVE

           .if (!(gbNowCapturing && gbLButtonDown))
        jmp skip                ; Same comment as above
        .endif

           .if gbCaptRect
                jmp skip
        .endif

            ; get the current mouse position

            invoke GetCursorPos, ADDR pt

            ; Get Window that we clicked on

            invoke WindowFromPoint, pt.x, pt.y  ; ### May be a problem here ?
            mov hWndCurrent, eax

            ;.if the cursor is still moving in the current window, no need
            ; to highlight it again

        mov eax, hBrowseWnd
           .if hWndCurrent != eax

                invoke FrameWindow, hBrowseWnd
                invoke FrameWindow, hWndCurrent
                M2M hBrowseWnd, hWndCurrent;
               .if hWndCurrent
                    invoke UpdateWindow, hWndCurrent
            .endif
            .endif

        .elseif eax==WM_CLOSE

           .if gbSave

                invoke  MessageBox, hWnd, ADDR Want2Sav, ADDR szAppName, \
                MB_ICONEXCLAMATION or MB_YESNOCANCEL
        mov  wRet,eax
               .if wRet==IDYES
                    invoke SaveBmp
                .elseif wRet==IDCANCEL
            jmp skip
        .endif

            .endif

        invoke IsWindow, hSelectDlg
           .if eax
                invoke DestroyWindow,hSelectDlg
        .endif

        invoke IsWindow, hRectangleDlg
           .if eax
                invoke DestroyWindow, hRectangleDlg
        .endif

        invoke DefWindowProc, hWnd, wMessage, wParam, lParam
            return eax

        .elseif eax==WM_DESTROY     ; Clean up
            invoke DeleteObject, ghbmLogo

           .if ghBitmap
                invoke DeleteObject, ghBitmap
        .endif

           .if ghPal
                invoke DeleteObject, ghPal
        .endif

            invoke PostQuitMessage, 0

    .elseif eax==WM_HELP

        invoke WinHelp, hWnd, ADDR szHelp, HELP_CONTENTS, 0

    .else

       invoke DefWindowProc, hWnd, wMessage, wParam, lParam
        ret
    .endif

skip:   xor eax,eax
        ret
;---------------------------------------
WndProc ENDP
;
;
;---------------------------------------
; FullViewWndProc
;
; This is our full-screen popup window procedure. It is used to display an
; image using the entire screen. Clicking the left mouse button restores
; to the main app window.
;---------------------------------------
FullViewWndProc PROC hWnd:HWND, msg:UINT, wParam:WPARAM, lParam:LPARAM
;---------------------------------------
    LOCAL ps:PAINTSTRUCT, rect:RECT, rectClient:RECT
    LOCAL bm:BITMAP, hOldBm:DWORD, hMemDC:HDC,x:DWORD, y:DWORD

   .if msg==WM_PAINT

            invoke BeginPaint, hWnd, ADDR ps

           .if !ghBitmap   ; Check to see if we are displaying a bitmap

               .if bStartup    ; No bitmap yet, are we in start mode?

                    invoke GetClientRect, hWnd, ADDR rectClient
            invoke CreateCompatibleDC, ps.hdc
                    mov hMemDC, eax

            invoke SelectObject, hMemDC, ghbmLogo   ; Logo bitmap
                    mov hOldBm, eax
                    invoke GetObject, ghbmLogo, sizeof BITMAP, ADDR bm

            mov eax, rectClient.right
            sub eax, bm.bmWidth
            shr eax,1
            mov x, eax  ; x = (rectClient.right - bm.bmWidth) / 2

            mov eax, rectClient.bottom
            sub eax, bm.bmHeight
            shr eax, 1
            mov y, eax  ;  y = (rectClient.bottom - bm.bmHeight) / 2

;           Now bitblt our logo to client area

                    invoke BitBlt, ps.hdc, x, y, bm.bmWidth, bm.bmHeight, \
                          hMemDC, 0, 0, SRCCOPY

                    ; Clean up

                    invoke SelectObject, hMemDC, hOldBm
                    invoke DeleteDC, hMemDC

                .endif
            .else

                ; Get info for captured bitmap

                invoke GetObject, ghBitmap, sizeof BITMAP, ADDR bm

                ; Fill in src/dest rectangle with width and height
                ; of captured bitmap

                mov rect.left, 0
                mov rect.top, 0

                M2M rect.right, bm.bmWidth
                M2M rect.bottom, bm.bmHeight

                ; Paint the captured bitmap in the client area

        invoke PaintBitmap, ps.hdc, ADDR rect, ghBitmap, ADDR rect, ghPal
            .endif

            invoke EndPaint, hWnd, ADDR ps

        .elseif msg==WM_KEYDOWN || msg==WM_LBUTTONDOWN

            invoke DestroyWindow, hWnd

        .else
        invoke DefWindowProc, hWnd, msg, wParam, lParam
        return eax
    .endif

    ret
;---------------------------------------
FullViewWndProc ENDP
;
;
SaveBmp     PROC
;---------------------------------------
;   PROC call up the common dialog "File.save" box, then saves
;   the current bitmap as a DIB in the specified file, in the
;   file format specified by the user in the dialog.
;---------------------------------------
    LOCAL hDC:HDC ;dwFlags:DWORD
    LOCAL iBits:DWORD, bResult:DWORD, hDIB:DWORD
    LOCAL dCompression:DWORD, wCompression:WORD, wBitCount:WORD

    mov wCompression, IDD_RGB       ; Set up default compression to
                        ; display in the dialog box.

;   Depending on the bits/pixel type for the display,
;   set the appropriate bit in the fFileOptions flag.
;   NB: we don't just assign wBitCount to iBits, because some displays
;   aren't 1/4/8 or 24 bits; some are 15 bits, which isn't valid for a DIB
;   so in this case we should set the bits to 24.

    invoke  CreateDC, ADDR szDisplay,0,0,0
    mov hDC, eax

    invoke  GetDeviceCaps, hDC, BITSPIXEL   ; Compute (Bits per pixel)*Number of PLANES
    mov iBits, eax          ;
    invoke  GetDeviceCaps, hDC, PLANES  ;
    mov edx,0               ;
    mul iBits               ;
    mov iBits, eax          ;
    invoke  DeleteDC, hDC

   .if iBits <= 1
        mov wBitCount,1

    .elseif iBits <= 4
        mov wBitCount,4

    .elseif iBits <= 8
        mov wBitCount,8

    .else
        mov wBitCount,24        ; All bits/pixel cases set thus
    .endif

    xor eax,eax         ; Clear
    mov ax, wBitCount
    shl eax, 16         ; Move to high word
    or  ax, wCompression        ; set compression type in low word
    mov dwFlags, eax

    invoke  GetFileName, ghWnd, ADDR szFileBuff, ADDR dwFlags
    mov bResult,eax

   .if bResult ; Extract DIB specifications and save to file, (if user didn't cancel)

        LOWORD dwFlags

       .if     eax==IDD_RLE4
        mov dCompression, BI_RLE4

        .elseif eax==IDD_RLE8
        mov dCompression,BI_RLE8

        .elseif eax==IDD_RGB
        mov dCompression,BI_RGB

        .else
        mov dCompression,BI_RGB
        .endif
    .else
        ret
    .endif

;   Bring up a modeless dialog which tells us we are saving this to a file
;   ----------------------------------------------------------------------

   .if !hModelessDlg

        invoke CreateDialogParam, ghInst2, ADDR szSaving, ghWnd, \
            ADDR SavingDlg, ADDR szFileBuff
        mov hModelessDlg, eax

;       Now write out the DIB in the proper format. The API
;       "ChangeBitmapFormat" converts the specified bitmap to a DIB with
;       the specified bit-count,compression and palette.
;       NB: the HIWORD of dwFlags specifies bits/pixel

        HIWORD dwFlags
        invoke ChangeBitmapFormat, ghBitmap, eax, dCompression, ghPal
        mov  hDIB, eax

    .endif

   .if hDIB

        invoke SaveDIB, hDIB, ADDR szFileBuff

       .if !eax
        invoke MessageBox,0,ADDR szCantSave, ADDR szSaveError, \
                 MB_ICONEXCLAMATION
        mov gbSave, TRUE
        .else
        mov gbSave, FALSE
        .endif

;       invoke DestroyDIB, hDIB ; Not used now we call GlobalFree directly
        invoke GlobalFree, hDIB

        invoke DestroyWindow, hModelessDlg
        mov    hModelessDlg, 0

    .endif

    ret
;---------------------------------------
SaveBmp     ENDP
;
;
PrintSetup  PROC uses ebx, pPrintdlg:DWORD, hwnd:DWORD
;---------------------------------------
    mov ebx, pPrintdlg

    mov PRINTDLG.lStructSize[ebx], SIZEOF PRINTDLG
    M2M PRINTDLG.hwndOwner[ebx],hwnd
    mov PRINTDLG.hDevMode[ebx],0
    mov PRINTDLG.hDevNames[ebx],0
    mov PRINTDLG.hDC[ebx],0
    mov PRINTDLG.Flags[ebx],PD_RETURNDC or PD_NOSELECTION or PD_NOPAGENUMS
    mov PRINTDLG.nFromPage[ebx],0
    mov PRINTDLG.nToPage[ebx],0
    mov PRINTDLG.nMinPage[ebx],0
    mov PRINTDLG.nMaxPage[ebx],0
    mov PRINTDLG.nCopies[ebx],1
    mov PRINTDLG.hInstance[ebx],0
    mov PRINTDLG.lCustData[ebx],0
    mov PRINTDLG.lpfnPrintHook[ebx],0
    mov PRINTDLG.lpfnSetupHook[ebx],0
    mov PRINTDLG.lpPrintTemplateName[ebx],0
    mov PRINTDLG.lpPrintSetupTemplateName[ebx],0
    mov PRINTDLG.hPrintTemplate[ebx],0
    mov PRINTDLG.hSetupTemplate[ebx],0
    ret
;---------------------------------------
PrintSetup  ENDP
;
;
DoCapture   PROC uses esi edi, hWnd:DWORD, wCmd:DWORD, pAppName, ghWndMain:DWORD
;---------------------------------------
    LOCAL   msg:MSG, hBitmap:HBITMAP, hDC:HDC
    LOCAL hWndSelect:DWORD, hWndDesktop:DWORD

   .if wCmd==IDM_DESKTOP   ; Copy Entire screen to DIB

        invoke CreateDC, ADDR szDisplay, 0,0,0
        mov hDC, eax

        mov rScreen.left, 0     ; Initialise
        mov rScreen.top, 0

        invoke GetDeviceCaps, hDC, HORZRES
        mov rScreen.right, eax
        invoke GetDeviceCaps, hDC, VERTRES
        mov rScreen.bottom,eax

        invoke DeleteDC, hDC

;       Set window Text
;       ---------------

        mov esi, offset szEntireScreen  ; Source
        mov edi, offset gszWindowText   ; Dest
        mov ecx, 14             ; Length of source
        rep movsb               ; Copy to target

        .WHILE              ; Wait until all repainted
        invoke PeekMessage, ADDR msg, 0,0,0, PM_REMOVE
        .BREAK .if !eax
        invoke TranslateMessage, ADDR msg
        invoke DispatchMessage,  ADDR msg
        .ENDW

        invoke CopyScreenToBitmap, ADDR rScreen
        mov hBitmap, eax

       .if hBitmap

        invoke GetSystemPalette

            mov hPal, eax
        .else
            mov hPal, 0
        .endif

    .elseif wCmd==IDM_CAPTRECT  ; Copy user-selected portuion of screen to DIB, allowing
                    ; user to "rubberband" section of the screen for capture
            invoke RubberBandScreen, ADDR rRubberBand, ghWndMain

;           Set window Text
;           ---------------

            mov esi, offset szUserPortion   ; Source
            mov edi, offset gszWindowText   ; Dest
            mov ecx, 22         ; Length of source
            rep movsb           ; Copy to target

        invoke CopyScreenToBitmap, ADDR rRubberBand
        mov  hBitmap, eax

       .if hBitmap
            invoke GetSystemPalette
            mov hPal, eax
        .else
            mov hPal, 0
        .endif

    .elseif wCmd==IDM_CAPTWINDOW || wCmd==IDM_CAPTCLIENT || wCmd==IDM_ACTIVEWINDOW

       .if wCmd==IDM_ACTIVEWINDOW  ; Capture the current window, whatever it is

            invoke GetForegroundWindow
            mov hWndSelect, eax
        .else           ; Allow user to click on a single window to capture

        M2M hWndSelect, ghWndCapture
        .endif

;   If tried to capture the desktop window, then just capture the entire screen.
;       ----------------------------------------------------------------------------

        invoke  GetDesktopWindow
        mov     hWndDesktop, eax

       .if hWndSelect==eax

            invoke CreateDC, ADDR szDisplay, 0,0,0
            mov hDC, eax

            mov rScreen.left, 0
            mov rScreen.top, 0

            invoke GetDeviceCaps, hDC, HORZRES
            mov rScreen.right, eax
            invoke GetDeviceCaps, hDC, VERTRES
            mov rScreen.bottom,eax

            invoke DeleteDC, hDC

;           Set window Text
;           ---------------

            mov esi, offset szEntireScreen  ; Source
            mov edi, offset gszWindowText   ; Dest
            mov ecx, 14         ; Length of source
            rep movsb           ; Copy to target

;       Wait until everybody repaints themselves

            .WHILE
            invoke PeekMessage, ADDR msg, 0,0,0, PM_REMOVE
            .BREAK .if !eax
            invoke TranslateMessage, ADDR msg
            invoke DispatchMessage,  ADDR msg
            .ENDW

            invoke CopyScreenToBitmap, ADDR rScreen
            mov ghBitmap, eax

            .if ghBitmap
            invoke GetSystemPalette
                mov ghPal, eax      ; ghPal is handle to bitmap palette
            .else
                mov ghPal, 0
            .endif

        mov ghWndCapture, 0

        ret

        .endif

;       Check that hWnd is not NULL
;       ---------------------------

        .if !hWndSelect

        invoke MessageBox,0, ADDR szCantCapt, pAppName, \
                  MB_ICONEXCLAMATION or MB_OK
        mov hBitmap,0
        mov hPal,0
        jmp cont
        .endif

;       Make sure its not a hidden window
;       ---------------------------------

        invoke IsWindowVisible, hWndSelect

        .if !eax
        invoke MessageBox,0,ADDR szNotVisible, pAppName,\
                    MB_ICONEXCLAMATION or MB_OK
        mov ghWndCapture,0
        mov hBitmap,0
        mov hPal,0
        jmp cont
        .endif

;       Move the selected window to top of z-order for capture and make it redraw
;       -------------------------------------------------------------------------

        invoke SetWindowPos, hWndSelect, 0,0,0,0,0, \
                 SWP_DRAWFRAME or SWP_NOSIZE or SWP_NOMOVE
        invoke UpdateWindow, hWndSelect


;       Wait while windows are repainted
;       --------------------------------

        .WHILE TRUE
        invoke PeekMessage, ADDR msg, 0,0,0, PM_REMOVE
        .BREAK .if !eax
        invoke TranslateMessage, ADDR msg
        invoke DispatchMessage,  ADDR msg
        .ENDW

;       Get the window caption
;       ----------------------
        invoke GetWindowText, hWndSelect, ADDR gszWindowText, 100

;           =================================================================
;       Capture the screen - if we select CLIENT only capture, the select
;       that when calling the api, otherwise get the entire window.
;           =================================================================

        .if wCmd==IDM_CAPTCLIENT
            mov eax, PW_CLIENT
        .else
            mov eax, PW_WINDOW
        .endif

        invoke CopyWindowToBitmap, hWndSelect, eax

        mov hBitmap, eax

        .if hBitmap
        invoke GetSystemPalette
            mov hPal, eax       ; ghPal is handle to bitmap palette
        .else
            mov hPal, 0
        .endif
;       ret             ; #### Remove ?

    .else

;       Something went wrong !
;       ----------------------

        invoke MessageBox,0,ADDR szInternalErr, ADDR pAppName, \
                MB_ICONHAND or MB_OK
    .endif
cont:
    .if hBitmap
        M2M ghBitmap, hBitmap
        mov hBitmap,0
    .endif

    .if hPal
        M2M ghPal, hPal
        mov hPal, 0
    .endif

;   Now paint the bitmap in the client area
;   ---------------------------------------

    .if bStartup
        mov bStartup, 0
    .endif

    invoke InvalidateRect, hWnd,0,0
    invoke UpdateWindow, hWnd
    mov ghWndCapture,0

    ret
;---------------------------------------
DoCapture   ENDP
;
;
RubberBandScreen    PROC    pRect:DWORD, ghWndMain:DWORD
;---------------------------------------
    LOCAL pt2:POINT     ; Temporary Point
    LOCAL msg:MSG, ptOrigin:POINT, pts:POINTS,rcClip:RECT
    LOCAL hScreenDC:HDC,bCapturing:DWORD, bLButtonUp:DWORD

;---------------------------------------
; Function allows user to rubber-band a portion of the screen.
;   When the left button is released, the selected rectangle, in
;   screen coordinates, is returned in pRect
;---------------------------------------
    mov bCapturing, FALSE   ; It's true when Rubber-banding
    mov     bLButtonUp, FALSE

    invoke  CreateDC, ADDR szDisplay, 0,0,0
    mov hScreenDC, eax

;   Eat mouse messages until a WM_LBUTTONUP is encountered. Meanwhile
;   continue to draw a rubberbanded rectangle & display its dimensions

    .WHILE  TRUE

        invoke WaitMessage
        invoke PeekMessage, ADDR msg,0, WM_MOUSEFIRST, WM_MOUSELAST, PM_REMOVE

        .if eax
;---------------------------------------;
; If the message is WM_LBUTTONDOWN then ;
; begin drawing the rubber-band box.    ;
;---------------------------------------;
        .if msg.message==WM_RBUTTONDOWN
;---------------------------------------
;           User pressed left button, initialize selection
;           Set origin to current mouse position (in window coords)
;---------------------------------------
            mov eax, msg.lParam     ; Contains Y in high word, x on low word
            mov pts.x, ax       ; Transfer "x" to Points structure
            shr eax, 16         ; Move high into low word
            mov pts.y, ax       ; Transfer "y"
            mov eax,0           ;
            mov ax, pts.x       ; Copy coords from structure to structure
            mov ptOrigin.x, eax     ;
            mov ax, pts.y       ;
            mov ptOrigin.y, eax     ;
;       Convert to screen coordinates
            invoke ClientToScreen, ghWndMain, ADDR ptOrigin
            M2M rcClip.left,   ptOrigin.x   ; rcClip is the current rectangle
            M2M rcClip.right,  ptOrigin.x   ; that the user has selected.
            M2M rcClip.top,    ptOrigin.y   ; Since user just pressed left button
            M2M rcClip.bottom, ptOrigin.y   ; down, initialize this rect very small
            invoke NormalizeRect, ADDR rcClip       ; Make sure its a normal rect
            invoke DrawSelect, hScreenDC, ADDR rcClip ; Draw the rubber-band box
                mov bCapturing, TRUE
        .elseif msg.message==WM_LBUTTONUP
            .if bCapturing
            mov bLButtonUp, TRUE
            invoke PostMessage, ghWndMain, WM_RBUTTONUP, msg.wParam, msg.lParam
            .else
            ret
            .endif
        .endif
;---------------------------------------
;       Messages that make it into the next statement are mouse messages
;       and we are capturing, so let's update the rubber-band box
;---------------------------------------
        .if bCapturing
            invoke DrawSelect, hScreenDC, ADDR rcClip  ; erase rubber-band
            M2M rcClip.left, ptOrigin.x     ; Update rect with new mouse info
            M2M rcClip.top, ptOrigin.y
            mov eax, msg.lParam     ; Contains Y in high word, x on low word
            mov pts.x, ax       ; Transfer "x" to Points structure
            shr eax, 16         ; Move high into low word
            mov pts.y, ax           ; Transfer "y"

            mov eax,0           ;
            mov ax, pts.x       ; Copy coords from structure to structure
            mov pt2.x, eax      ;
            mov ax, pts.y       ;
            mov pt2.y, eax      ;

;       Convert to screen coordinates

            invoke ClientToScreen, ghWndMain, ADDR pt2
            M2M rcClip.right,  pt2.x
            M2M rcClip.bottom, pt2.y
            invoke NormalizeRect, ADDR rcClip   ; New rubber-band
            invoke DrawSelect, hScreenDC, ADDR rcClip  ; new rubber-band

        .endif

;       If message is WM_LBUTTONUP, then we stop the selection process

        .if msg.message==WM_RBUTTONUP
            invoke DrawSelect, hScreenDC, ADDR rcClip

            .if bLButtonUp
            invoke PostMessage, ghWndMain,WM_LBUTTONUP,msg.wParam, msg.lParam
            jmp cont    ; Escape from Draw-Select loop
            .endif

        .endif

        .endif

    .ENDW
cont:
        invoke DeleteDC, hScreenDC

;       Assign rect user selected to lpRect parameter

        invoke IsRectEmpty, ADDR rcClip

        .if !eax
            invoke CopyRect, pRect, ADDR rcClip
        .endif

    invoke PostMessage, ghWndMain, WM_LBUTTONUP, msg.wParam, msg.lParam
    ret
;---------------------------------------
RubberBandScreen    ENDP
;
;
DrawSelect  PROC uses ebx,  hdc:HDC, pClip:DWORD
;---------------------------------------
; Draws the selected clip recangle with its dimensions on the DC
;---------------------------------------
    LOCAL x:DWORD,y:DWORD,dxx:DWORD, dy:DWORD, len:DWORD, hdcBits:HDC

    mov ebx, pClip
    invoke IsRectEmpty, pClip

        ;--------------------------------------------------------
    .if !eax    ; If a rectangular clip region has been selected, draw it
        ;--------------------------------------------------------

    mov eax, RECT.right[ebx]
    sub eax, RECT.left[ebx]

        invoke PatBlt, hdc, RECT.left[ebx], RECT.top[ebx], eax, 1, DSTINVERT

    mov eax, RECT.top[ebx]
    sub eax, RECT.bottom[ebx]

        invoke PatBlt, hdc, RECT.left[ebx], RECT.bottom[ebx], 1, eax, DSTINVERT

    mov eax, RECT.bottom[ebx]
    sub eax, RECT.top[ebx]
    mov ecx, RECT.right[ebx]
    dec ecx

        invoke PatBlt, hdc, ecx, RECT.top[ebx], 1, eax, DSTINVERT

    mov eax, RECT.left[ebx]
    sub eax, RECT.right[ebx]
    mov ecx, RECT.bottom[ebx]
    dec ecx

        invoke PatBlt, hdc, RECT.right[ebx], ecx, eax, 1, DSTINVERT

        invoke DeleteDC, hdcBits

    .endif

    ret
;---------------------------------------
DrawSelect  ENDP
;
;
NormalizeRect   PROC    uses ebx, prc:DWORD
;---------------------------------------
; If rectangle coords are reversed, swap them.
;   This is used to ensure that the 1st coord of the rectangle
;   is the upper left and the 2nd the lower right
;---------------------------------------
    mov ebx, prc
    mov eax, RECT.left[ebx]
    .if RECT.right[ebx] < eax
        mov  eax, RECT.right[ebx]   ; load right
        xchg eax, RECT.left[ebx]    ; right into left
        xchg eax, RECT.right[ebx]   ; left  into right
    .endif

    mov eax, RECT.top[ebx]

    .if RECT.bottom[ebx] < eax
        mov  eax, RECT.bottom[ebx]  ; load bottom
        xchg eax, RECT.top[ebx] ; bottom into top
        xchg eax, RECT.bottom[ebx]  ; top  into bottom
    .endif

    ret
;---------------------------------------
NormalizeRect   ENDP
;
;
;---------------------------------------
; DoSize:
;       Called by WndProc on WM_SIZE
;
;           When the window is sized -- set up the scroll bars.
;
;           The window will be repainted if the new size, combined
;           with the current scroll bar positions would create blank
;           space at the left or bottom of the window.
;---------------------------------------
DoSize  PROC    hWnd:HWND
;---------------------------------------
    LOCAL rect:RECT                     ; Client rectangle
    LOCAL bm:BITMAP             ; Bitmap info structure
    LOCAL cxBitmap:DWORD, cyBitmap:DWORD    ; Bitmap width and height
    LOCAL cxScroll:DWORD, cyScroll:DWORD    ; Scroll positions

    mov cxBitmap, 0
    mov cyBitmap, 0

; Repaint if displaying bitmap

    .if ghBitmap

        ; Get info about bitmap

        invoke GetObject, ghBitmap, sizeof BITMAP, ADDR bm

        ; Get the width and height of the bitmap

        M2M cxBitmap, bm.bmWidth
        M2M cyBitmap, bm.bmHeight

        ; Find out the dimensions of the window, and the current thumb
        ; positions

        invoke GetClientRect, hWnd, ADDR rect

        invoke GetScrollPos, hWnd, SB_HORZ
    mov cxScroll, eax
        invoke GetScrollPos, hWnd, SB_VERT
        mov cyScroll, eax

        ; If current thumb positions would cause blank space
        ; at right or bottom of client area, repaint

        mov eax, cxScroll
    add eax, rect.right
        mov ecx, cyScroll
    add ecx, rect.bottom

        .if eax > cxBitmap || ecx > cyBitmap
            invoke InvalidateRect, hWnd, NULL, NULL
    .endif

        ; Make sure scroll bars are updated

        invoke SetupScrollBars, hWnd, cxBitmap, cyBitmap

    .elseif bStartup
        invoke InvalidateRect, hWnd, NULL, TRUE
    .endif

    ret
;---------------------------------------
DoSize  ENDP
;
;
;---------------------------------------
; ReallyGetClientRect:
;
; Gets the rectangular area of the client rect including
; the area underneath visible scroll bars.  Stolen from ShowDIB
;---------------------------------------
ReallyGetClientRect PROC uses ebx, hWnd:HWND, lpRect:DWORD
;---------------------------------------
    LOCAL dwWinStyle:DWORD

    mov ebx, lpRect

    invoke GetWindowLong, hWnd, GWL_STYLE
    mov dwWinStyle, eax

    invoke GetClientRect, hWnd, lpRect

    .if dwWinStyle && WS_HSCROLL
        invoke GetSystemMetrics, SM_CYHSCROLL
        dec eax
        add RECT.bottom[ebx], eax
    .endif

    .if dwWinStyle && WS_VSCROLL
        invoke GetSystemMetrics, SM_CXVSCROLL
        dec eax
        add RECT.right[ebx], eax
        .endif

    ret
;---------------------------------------
ReallyGetClientRect ENDP
;
;
SetupScrollBars PROC    hWnd:HWND, cxBitmap:DWORD, cyBitmap:DWORD
;---------------------------------------
        LOCAL rect:RECT                       ; Client Rectangle
        LOCAL bNeedScrollBars:DWORD           ; Need Scroll bars?
        LOCAL cxWindow:DWORD, cyWindow:DWORD  ; Width and height of client area
        LOCAL cxRange:DWORD, cyRange:DWORD    ; Range needed for horz and vert

        mov bNeedScrollBars, FALSE
        mov cxRange,0
        mov cyRange,0

        invoke ReallyGetClientRect, hWnd, ADDR rect
    mov eax, rect.right
    sub eax, rect.left
        mov cxWindow, eax
        mov eax, rect.bottom
    sub eax, rect.top
        mov cyWindow, eax

;   Now determine if we need the scroll bars

        mov eax, cxBitmap
        mov ecx, cyBitmap
        .if cxWindow < eax || cyWindow < ecx
            mov bNeedScrollBars, TRUE
        .endif

    ; Setup the scroll bar ranges.  We want to be able to
    ; scroll the window so that all the bitmap can appear
    ; within the client area.  Take into account that
    ; if the opposite scroll bar is activated, it eats
    ; up some client area.

        .if bNeedScrollBars
        invoke  GetSystemMetrics, SM_CYHSCROLL
        add eax, cyBitmap ; unsigned ?
        sub eax, cyWindow
        dec eax
        mov cyRange, eax

        invoke  GetSystemMetrics, SM_CXVSCROLL
        add eax, cxBitmap ; unsigned ?
        sub eax, cxWindow
        dec eax
        mov cxRange, eax
        .endif

    ; Set the ranges we've calculated (0 to 0 means invisible scrollbar)

        invoke SetScrollRange, hWnd, SB_VERT, 0, cyRange, TRUE
        invoke SetScrollRange, hWnd, SB_HORZ, 0, cxRange, TRUE

    ret
;---------------------------------------
SetupScrollBars ENDP
;
;
;---------------------------------------
;
; DoScroll:
;
; Purpose:    Called by ChildWndProc on WM_HSCROLL and WM_VSCROLL.
;             Window needs to be scrolled (user has clicked on one
;             of the scroll bars.
;
;             Does scrolling in both horiziontal and vertical directions.
;             Note that the variables are all named as if we were
;             doing a horizontal scroll.  However, if we're doing a
;             vertical scroll, they are initialized to the appropriate
;             values for a vertical scroll.
;
;             If we scroll by one (i.e. user clicks on one of the
;             scrolling arrows), we scroll the window by 1/SCROLL_RATIO
;             of the client area.  In other words, if SCROLL_RATION==4,
;             then we move the client area over a 1/4 of the width/height
;             of the screen.
;
;             If the user is paging up/down we move a full client area's
;             worth.
;
;             If the user moves the thumb to an absolute position, we
;             just move there.
;
;             ScrollWindow/re-painting do the actual work of scrolling.
;---------------------------------------
DoScroll    PROC    hWnd:HWND, message:DWORD, wPos:DWORD, wScrollType:DWORD
;---------------------------------------
    LOCAL rect:RECT     ; Client area.
    LOCAL xBar:DWORD    ; Where scrollbar is now.
    LOCAL nMin:DWORD    ; Minumum scroll bar value.
    LOCAL nMax:DWORD    ; Maximum scroll bar value.
    LOCAL dxx:DWORD     ; How much to move.
    LOCAL nOneUnit:DWORD    ; # of pixels for LINEUP/LINEDOWN
    LOCAL cxClient:DWORD    ; Width of client area.
    LOCAL nHorzOrVert:DWORD ; Doing the horizontal or vertical?

    invoke GetClientRect, hWnd, ADDR rect

    .if message==WM_HSCROLL

        mov nHorzOrVert, SB_HORZ
        mov eax, rect.right
        sub eax, rect.left
    .else
            mov nHorzOrVert, SB_VERT
        mov eax, rect.bottom
        sub eax, rect.top
    .endif

    mov cxClient, eax   ; cxClient = rect.right-rect.left, or rect.bottom-rect.top

;   On a SB_LINEUP/SB_LINEDOWN we will move the DIB by
;   1/SCROLL_RATIO of the client area (i.e..if SCROLL_RATIO
;   is 4, it will scroll the DIB a quarter of the client
;   area's height or width.

    mov edx,0
    mov eax, cxClient
    mov ecx, SCROLL_RATIO
    div ecx
    mov nOneUnit, eax   ; nOneUnit = cxClient / SCROLL_RATIO;

    .if !nOneUnit
            mov nOneUnit, 1
    .endif

    invoke GetScrollPos, hWnd, nHorzOrVert
    mov xBar, eax

    invoke GetScrollRange, hWnd, nHorzOrVert, ADDR nMin, ADDR nMax

    .if wScrollType==SB_LINEDOWN    ; One line right.

        M2M dxx, nOneUnit

        .elseif wScrollType==SB_LINEUP  ; One line left.

        mov eax, nOneUnit
        neg eax
        mov dxx, eax

    .elseif wScrollType==SB_PAGEDOWN ; One page right.

        M2M dxx, cxClient

        .elseif wScrollType==SB_PAGEUP  ; One page left.

        mov eax, cxClient
        neg eax
        mov dxx, eax

    .elseif wScrollType==SB_THUMBPOSITION   ; Absolute position.

        mov eax, wPos
        sub eax, xBar
        mov dxx, eax

    .else               ; No change.
        mov dxx, 0
    .endif

    .if dxx

        mov eax, dxx
        add xBar, eax

        mov eax, nMin
        .if xBar < eax
        mov eax, xBar
        sub eax, nMin
        sub dxx, eax        ;  dxx -= xBar - nMin
        M2M xBar, nMin
        .endif

        mov eax, nMax
            .if xBar > eax
        mov eax, xBar
        sub eax, nMax
        sub dxx, eax        ;  dxx -= xBar - nMax
                M2M xBar, nMax
        .endif

            .if dxx

                invoke SetScrollPos, hWnd, nHorzOrVert, xBar, TRUE

                .if nHorzOrVert==SB_HORZ
            mov eax, dxx
            neg eax
                    invoke ScrollWindow, hWnd, eax, 0, 0, 0
                .else
            mov eax, dxx
            neg eax
                    invoke ScrollWindow, hWnd, 0, eax, 0, 0
        .endif

                invoke UpdateWindow, hWnd
        .endif

    .endif

    ret
;---------------------------------------
DoScroll    ENDP
;
;
DoPaint     PROC    hWnd:HWND   ; Called by WndProc. Does painting for client area.
;---------------------------------------
    LOCAL rectClient:RECT, rectDDB:RECT ; Client and bitmap rectangles
    LOCAL ps:PAINTSTRUCT         ; Painting structure
    LOCAL hDC:HDC, hMemDC:HDC    ; Handle to DC, memory DC
    LOCAL bm:BITMAP          ; BITMAP structure
    LOCAL hOldBm:DWORD       ; Handle to previous bitmap
    LOCAL xScroll:DWORD, yScroll:DWORD; Scroll positions
    LOCAL x:DWORD, y:DWORD       ; Logo origin
    LOCAL dxx:DWORD, dy:DWORD

;   Begin painting

    invoke BeginPaint, hWnd, ADDR ps
    mov hDC, eax

;   Check to see if we are displaying a bitmap

        .if !ghBitmap

;       No bitmap yet, are we in start mode?

        .if bStartup

        invoke GetClientRect, hWnd, ADDR rectClient
        invoke CreateCompatibleDC, ps.hdc
        mov hMemDC, eax

;       Select our logo bitmap

        invoke SelectObject, hMemDC, ghbmLogo
        mov hOldBm, eax

        invoke GetObject, ghbmLogo, sizeof BITMAP, ADDR bm

        mov eax, rectClient.right
        sub eax, bm.bmWidth
        shr eax, 1
        mov x, eax  ; x = (rectClient.right - bm.bmWidth) / 2

        mov eax, rectClient.bottom
        sub eax, bm.bmHeight
        shr eax, 1
        mov y, eax  ; y = (rectClient.bottom - bm.bmHeight)/2

            ; Now bitblt the logo to client area

                invoke BitBlt, ps.hdc, x, y, bm.bmWidth, bm.bmHeight, \
               hMemDC, 0, 0, SRCCOPY
;       Clean up

        invoke SelectObject, hMemDC,hOldBm
        invoke DeleteDC, hMemDC

        .else

;           Turn off scroll bars in case they were on

        invoke SetScrollRange, hWnd, SB_VERT, 0, 0, TRUE
        invoke SetScrollRange, hWnd, SB_HORZ, 0, 0, TRUE

        .endif

        .else ; We are displaying a bitmap

;       Get bitmap info

            invoke GetObject, ghBitmap, sizeof BITMAP, ADDR bm

;       Get scroll bar positions

        invoke GetScrollPos, hWnd, SB_HORZ
        mov xScroll, eax
        invoke GetScrollPos, hWnd, SB_VERT
        mov yScroll, eax

;       Set up the scroll bars appropriately.

        invoke SetupScrollBars, hWnd, bm.bmWidth, bm.bmHeight

;       Set up the necessary rectangles -- i.e. the rectangle
;       we're rendering into, and the rectangle in the bitmap

        invoke GetClientRect, hWnd, ADDR rectClient

        M2M rectDDB.left, xScroll
        M2M rectDDB.top,  yScroll

        mov eax, xScroll
        add eax, rectClient.right
        sub eax, rectClient.left
        mov rectDDB.right, eax ; rectDDB.right = xScroll + rectClient.right - rectClient.left

        mov eax, yScroll
        add eax, rectClient.bottom
        sub eax, rectClient.top
        mov rectDDB.bottom, eax ; rectDDB.bottom = yScroll + rectClient.bottom - rectClient.top

        mov eax, bm.bmWidth

            .if rectDDB.right > eax
        mov eax, bm.bmWidth
        sub eax, rectDDB.right
        mov dxx, eax        ; dxx = bm.bmWidth - rectDDB.right

        add rectDDB.right, eax
        add rectClient.right, eax
        .endif

        mov eax, bm.bmHeight

        .if rectDDB.bottom > eax

        mov eax, bm.bmHeight
        sub eax, rectDDB.bottom
        mov dy, eax     ; dy = bm.bmHeight - rectDDB.bottom

        add rectDDB.bottom, eax
        add rectClient.bottom, eax
        .endif

;      Do the actual painting

        lea eax, rectClient
        lea ecx, rectDDB
        invoke PaintBitmap, hDC, eax, ghBitmap, ecx, ghPal

        .endif

        invoke EndPaint, hWnd, ADDR ps

    ret

DoPaint ENDP
;
;
;---------------------------------------
; FrameWindow:  Highlight the window frame
;---------------------------------------
FrameWindow PROC    hWnd:HWND
;---------------------------------------
        LOCAL rc:RECT,  hdc:HDC
        DINV equ     3

    invoke IsWindow, hWnd

    .if !eax
            ret
    .endif

        invoke GetWindowDC, hWnd
    mov hdc, eax
        invoke GetWindowRect, hWnd, ADDR rc

    mov eax, rc.left
    neg eax     ; -rc.left
    mov ecx, rc.top
    neg ecx     ; -rc.top
        invoke OffsetRect, ADDR rc, eax, ecx

    invoke IsRectEmpty, ADDR rc

        .if !eax
        mov eax, rc.right
        sub eax, rc.left
            invoke PatBlt, hdc, rc.left, rc.top, eax, DINV, DSTINVERT
        mov eax, rc.bottom
        sub eax, DINV

        mov ecx, rc.top
        add ecx, DINV
        add ecx, DINV
        sub ecx, rc.bottom  ;  -(rc.bottom-rc.top-2*DINV)

            invoke PatBlt, hdc, rc.left, eax, DINV, ecx, DSTINVERT
        mov eax, rc.right
        sub eax, DINV
        mov edx, rc.top
        add edx, DINV

        mov ecx, rc.bottom
        sub ecx, rc.top
        sub ecx, DINV
        sub ecx, DINV   ; rc.bottom-rc.top-2*DINV

            invoke PatBlt, hdc, eax, edx, DINV, ecx, DSTINVERT
        mov eax, rc.bottom
        sub eax, DINV
        mov ecx, rc.left
        sub ecx, rc.right   ; -(rc.right-rc.left)

            invoke PatBlt, hdc, rc.right, eax, ecx, DINV, DSTINVERT
    .endif
        invoke ReleaseDC, hWnd, hdc

    ret
;---------------------------------------
FrameWindow ENDP
;
;
;---------------------------------------
;
; FUNCTION: CenterWindow
;
; PURPOSE:  Center one window over another
;
; COMMENTS:
;
;      Dialog boxes take on the screen position that they were designed at,
;      which is not always appropriate. Centering the dialog over a particular
;      window usually results in a better position.
;
;---------------------------------------
CenterWindow    PROC hwndChild:DWORD, hwndParent:DWORD
;---------------------------------------
    LOCAL rChild:RECT, rParent:RECT
    LOCAL wChild:DWORD, hChild:DWORD, wParent:DWORD, hParent:DWORD
    LOCAL wScreen:DWORD, hScreen:DWORD, xNew:DWORD, yNew:DWORD
    LOCAL hdc:DWORD

;   Get the Height and Width of the child window

    invoke GetWindowRect, hwndChild, ADDR rChild

    mov eax, rChild.right
    sub eax, rChild.left
    mov wChild, eax

    mov eax, rChild.bottom
    sub eax, rChild.top
    mov hChild, eax

;   Get the Height and Width of the parent window

    invoke GetWindowRect, hwndParent, ADDR rParent

    mov eax, rParent.right
    sub eax, rParent.left
    mov wParent, eax

    mov eax, rParent.bottom
    sub eax, rParent.top
    mov hParent, eax

;   Get the display limits

    invoke GetDC, hwndChild
    mov hdc, eax

    invoke GetDeviceCaps, hdc, HORZRES
    mov wScreen, eax

    invoke GetDeviceCaps, hdc, VERTRES
    mov hScreen, eax
    invoke ReleaseDC, hwndChild, hdc

;   Calculate new X position, then adjust for screen

    mov eax, wParent    ;    xNew = rParent.left + ((wParent - wChild) /2)
    sub eax, wChild
    shr eax, 1
    add eax, rParent.left
    mov xNew, eax

    mov eax, xNew
    add eax, wChild

    .if xNew < 0
        mov xNew, 0

    .elseif eax > wScreen

        mov eax, wScreen
        sub eax, wChild
        mov xNew, eax

    .endif

;   Calculate new Y position, then adjust for screen

    mov eax, hParent    ;    yNew = rParent.top  + ((hParent - hChild) /2);
    sub eax, hChild
    shr eax, 1
    add eax, rParent.top
    mov yNew, eax

    mov eax, yNew
    add eax, hChild

    .if yNew < 0
        mov yNew, 0

    .elseif eax > hScreen

        mov eax, hScreen
        sub eax, hChild
        mov yNew, eax

    .endif

;   Set it, and return

    invoke SetWindowPos, hwndChild, 0, xNew, yNew, 0, 0, \
        SWP_NOSIZE or SWP_NOZORDER
    ret
;---------------------------------------
CenterWindow    ENDP
;
;
;---------------------------------------
;   "About" Dialog Box Window Procedure
;
;   Notable features:  This dialog box draws the application's icon
;   in the dialog box itself. The icon is actually stretched larger
;   to fit in the specified area, which must be done manually.
;   See WM_PAINT case.
;---------------------------------------
AboutDlgProc    PROC hWndDlg:HWND, msg:UINT, wParam:WPARAM, lParam:LPARAM
;---------------------------------------
        LOCAL ps:PAINTSTRUCT
        LOCAL r1:RECT       ; Coordinates of TEXT1 control
        LOCAL p1:POINT      ; Used to convert screen to client coords
        LOCAL bm:BITMAP     ; For getting info about "About" bitmap
    LOCAL hbm:HBITMAP, hdcMem:HDC

         .if msg==WM_INITDIALOG ; Set focus on the OK button.
                ; Since we set focus, return FALSE
        invoke GetDlgItem, hWndDlg, IDOK
            invoke SetFocus, eax
            invoke LoadBitmap, ghInst2, szABOUTBMP
        mov ghAboutBmp, eax
            return FALSE

        .elseif msg==WM_CLOSE   ; Closing the Dialog behaves the same as Cancel

            invoke PostMessage, hWndDlg, WM_COMMAND, IDCANCEL, 0

        .elseif msg==WM_COMMAND

            .if wParam==IDOK || wParam==IDCANCEL

                invoke EndDialog, hWndDlg, FALSE
                .if ghAboutBmp
                    invoke DeleteObject, ghAboutBmp
        .endif
            .endif

        .elseif msg==WM_PAINT   ; Paint our bitmap in the about box in the WM_PAINT case

            invoke BeginPaint, hWndDlg, ADDR ps

;       Place screen coords of TEXT1 in r1

        invoke GetDlgItem, hWndDlg, IDC_TEXT1
            mov ecx, eax
            invoke GetWindowRect, ecx, ADDR r1

        M2M p1.x, r1.left
        M2M p1.y, r1.top

            invoke ScreenToClient, hWndDlg, ADDR p1

;       p1 now describes the location of upper-left corner
;       for the top text in the dialog.  Let's use this
;       to make sure we don't draw our bitmap over the text

            mov r1.left, 12
            M2M r1.top, p1.y

        mov eax, p1.x
        sub eax, 25
        mov r1.right, eax

            add eax, r1.top     ;
        sub eax, r1.left        ; Make it square
        mov r1.bottom, eax      ;

        invoke CreateCompatibleDC, ps.hdc
        mov hdcMem, eax

            .if hdcMem
                invoke GetObject, ghAboutBmp, sizeof BITMAP, addr bm
                invoke SelectObject, hdcMem, ghAboutBmp
        mov hbm, eax
                invoke StretchBlt, ps.hdc, r1.left, r1.top, r1.right, r1.bottom, \
                   hdcMem, 0, 0, bm.bmWidth, bm.bmHeight, SRCCOPY
                invoke SelectObject, hdcMem, hbm
                invoke DeleteDC, hdcMem
            .endif

            invoke EndPaint, hWndDlg, ADDR ps

        .else
            return FALSE;
        .endif

    return TRUE
;---------------------------------------
AboutDlgProc    ENDP
;
;
PrintDlgProc    PROC uses ebx , hWndDlg:HWND, msg:UINT, wParam:WPARAM, lParam:LPARAM
;---------------------------------------
    LOCAL flag:DWORD, szTmp[100]:BYTE

    .if msg==WM_INITDIALOG
;---------------------------------------
;       Because DialogBoxParam was used to invoke this dialog box,
;       lParam contains a pointer to the POPTION structure.
;---------------------------------------
;   Check the default button -- "BEST FIT"

        invoke CheckRadioButton, hWndDlg, IDC_BESTFIT, IDC_STRETCHTOPAGE, IDC_BESTFIT

;   Gray out the stuff under "SCALE"

        invoke GetDlgItem, hWndDlg, IDC_XAXIS
            invoke EnableWindow, eax, FALSE
        invoke GetDlgItem, hWndDlg, IDC_YAXIS
            invoke EnableWindow, eax, FALSE
        invoke GetDlgItem, hWndDlg, IDC_XTEXT
            invoke EnableWindow, eax, FALSE
        invoke GetDlgItem, hWndDlg, IDC_YTEXT
            invoke EnableWindow, eax, FALSE

    .elseif msg==WM_CLOSE       ; Closing the Dialog should behave the same as Cancel

        invoke SendMessage, hWndDlg, WM_COMMAND, IDCANCEL, 0

    .elseif msg==WM_COMMAND

        .if wParam==IDC_BESTFIT || wParam==IDC_STRETCHTOPAGE || wParam==IDC_SCALE

;       Check the correct button

                invoke CheckRadioButton, hWndDlg, IDC_BESTFIT, IDC_SCALE, wParam

;       Enable or disable the options under "Scale", depending
;       on whether or not the IDC_SCALE button is checked

        .if wParam==IDC_SCALE
            mov flag,TRUE   ; Set flag true
        .else
            mov flag,FALSE  ; or false
        .endif

        invoke GetDlgItem, hWndDlg, IDC_XAXIS
                invoke EnableWindow, eax, flag

        invoke GetDlgItem, hWndDlg, IDC_YAXIS
                invoke EnableWindow, eax, flag

                invoke GetDlgItem, hWndDlg, IDC_XTEXT
        invoke EnableWindow, eax, flag

        invoke GetDlgItem, hWndDlg, IDC_YTEXT
        invoke EnableWindow, eax, flag

        .elseif wParam==IDOK

;       Save the user's selection into the OPTIONSTRUCT
;       -----------------------------------------------

                .if !ebx
                        invoke EndDialog, hWndDlg, FALSE
                .endif

        invoke IsDlgButtonChecked, hWndDlg, IDC_BESTFIT
                .if eax
                    mov   opts.iOption, IDC_BESTFIT
        .endif

        invoke IsDlgButtonChecked, hWndDlg, IDC_STRETCHTOPAGE
                .if eax
                    mov   opts.iOption, IDC_STRETCHTOPAGE
        .endif

        invoke IsDlgButtonChecked, hWndDlg, IDC_SCALE
                .if eax
                    mov   opts.iOption, IDC_SCALE
        .endif

        invoke GetDlgItemInt, hWndDlg, IDC_XAXIS, 0, 0  ; Get X scale
        mov opts.iXScale, eax
        invoke GetDlgItemInt, hWndDlg, IDC_YAXIS, 0, 0  ; Get Y scale
        mov opts.iYScale, eax

                invoke EndDialog, hWndDlg, TRUE

        .elseif wParam==IDCANCEL
        invoke EndDialog, hWndDlg, FALSE
        .endif

    .else
        return FALSE
    .endif

    return  TRUE
;---------------------------------------
PrintDlgProc    ENDP
;
;
SavingDlg   PROC    hDlg:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
;---------------------------------------
    .if uMsg==WM_SETFOCUS
        invoke MessageBeep,0

    .elseif uMsg==WM_INITDIALOG

;       Set the text of the filename in the dialog box.  This dialog
;       should be called with DialogBoxParam, and the parameter should
;       be a pointer to the filename.  It shows up as the lParam here.

        invoke SetDlgItemText, hDlg, IDC_FILETEXT, lParam
        return TRUE

        .elseif uMsg==WM_DESTROY
        return TRUE
    .else
        return FALSE
    .endif
;---------------------------------------
SavingDlg   ENDP
;
;
;---------------------------------------
;
;     Selection Help Dialog Box Window Procedure
;
;     This is a modeless dialog box which displays
;     how to select a window to be captured
;
;---------------------------------------
SelectDlgProc   PROC, hDlg:HWND,  msg:UINT, wParam:WPARAM, lParam:LPARAM
;---------------------------------------
    LOCAL hMem:DWORD, pMem:DWORD

    .if msg==WM_INITDIALOG

            invoke GlobalAlloc, GHND, 200   ; Allocate 200 bytesmemory
        mov hMem, eax
        invoke GlobalLock,hMem      ; Convert handle to a memory Pointer
        mov pMem, eax

            .if pMem==NULL
                return TRUE         ; Abort if alloc fails
        .endif

            invoke LoadString, ghInst2, IDS_SELECT2, pMem, 200
            invoke SetDlgItemText, hDlg, IDC_STATIC_SELECT2, pMem
            invoke LoadString, ghInst2, IDS_SELECT3, pMem, 200
            invoke SetDlgItemText, hDlg, IDC_STATIC_SELECT3, pMem

            invoke GlobalUnlock, pMem
            invoke GlobalFree, hMem

            return TRUE

        .elseif msg==WM_COMMAND
            .if wParam != IDCANCEL
                return FALSE
            .else
                invoke ShowWindow, hDlg, SW_HIDE
                mov gbNowCapturing, FALSE
                return TRUE
        .endif
        .elseif msg==WM_SYSCOMMAND
            .if wParam==SC_CLOSE
                invoke ShowWindow, hDlg, SW_HIDE
                mov gbNowCapturing, FALSE
                return TRUE
            .else
                return FALSE;
        .endif
        .elseif msg==WM_DESTROY
            return TRUE
        .else
            return FALSE
    .endif
;---------------------------------------
SelectDlgProc   ENDP
;
;
;---------------------------------------
;
;     Selection Help Dialog Box Window Procedure
;
;     This is a modeless dialog box which displays
;     how to select a window to be captured
;
;====================================================
RectangleDlgProc    PROC hDlg:HWND, msg:UINT, wParam:WPARAM, lParam:LPARAM
;---------------------------------------
    LOCAL hMem:DWORD, pMem:DWORD

        .if msg==WM_INITDIALOG

            invoke GlobalAlloc,GHND, 200
        mov hMem, eax
            invoke GlobalLock, hMem
        mov pMem, eax

            .if hMem== NULL
                return TRUE
        .endif

            invoke LoadString,ghInst2, IDS_RECT2, pMem, 200
            invoke SetDlgItemText, hDlg, IDC_STATIC_RECT2, pMem
            invoke LoadString, ghInst2, IDS_RECT3, pMem, 200
            invoke SetDlgItemText, hDlg, IDC_STATIC_RECT3, pMem

            invoke GlobalUnlock, pMem
            invoke GlobalFree, hMem

            return TRUE

        .elseif msg==WM_COMMAND
            .if wParam != IDCANCEL
                return FALSE
            .else
                invoke ShowWindow, hDlg, SW_HIDE
                mov gbNowCapturing, FALSE
        mov gbCaptRect, FALSE
                return TRUE
            .endif

        .elseif msg==WM_SYSCOMMAND
            .if wParam==SC_CLOSE
                invoke ShowWindow, hDlg, SW_HIDE
                mov gbNowCapturing, FALSE
                return TRUE
            .else
                return FALSE
            .endif

        .elseif msg==WM_DESTROY
            return TRUE;
        .else
            return FALSE
    .endif
;---------------------------------------
RectangleDlgProc    ENDP
;
;
GetFileName PROC    uses ebx esi edi, hWndOwner:HWND, pszFileName, dwFlags2:DWORD
;---------------------------------------
    LOCAL ofn:OPENFILENAME
;   LOCAL fpDlgFunc:DWORD
    LOCAL CopyDwF:DWORD
    LOCAL bReturn:DWORD, dwLocalOpt:DWORD

;---------------------------------------
;   Parameter validation -- try to recover gracefully if dwFlags is NULL
;---------------------------------------
    .if dwFlags2==NULL
        lea eax, CopyDwF    ; Get address of local copy of flags
        mov dwFlags2, eax
    .endif

    mov ebx, dwFlags2   ; dwFlags is a pointer
    M2M dwLocalOpt,[ebx]    ; Make local copy of options

    mov ebx, pszFileName    ; Reset to point at filename string

;   Initialize the OPENFILENAME members

    mov esi, offset StarDotBMP
    mov edi, offset szFile
    mov ecx, 6          ; 6 chars inc terminal zero; 5 probably OK as 0 is added automatically
    rep movsb           ; Copy chars to szFile

    invoke LoadString, ghInst2, IDS_SAVEASTITLE, ADDR szTitle, 50   ; Get string from resource file

    mov ofn.lStructSize, sizeof OPENFILENAME
    M2M ofn.hwndOwner, hWndOwner
    M2M ofn.hInstance, ghInst2
    mov ofn.lpstrFilter, offset szFilter    ; Filter
    mov ofn.lpstrCustomFilter, 0
    mov ofn.nMaxCustFilter, 0
    mov ofn.nFilterIndex, 1
    M2M ofn.lpstrFile, offset szFile
    mov ofn.nMaxFile, MAXFILENAMELEN
    mov ofn.lpstrFileTitle, 0
    mov ofn.nMaxFileTitle,  0
    mov ofn.lpstrInitialDir,0
    M2M ofn.lpstrTitle, offset szTitle
    M2M ofn.Flags, OFN_ENABLETEMPLATE or OFN_HIDEREADONLY \
                   or OFN_OVERWRITEPROMPT ; or OFN_ENABLEHOOK ; #### Temp disable ####
    mov ofn.nFileOffset, 0                    ; as GetSaveFileName overwrites ofn.lCustData
    mov ofn.nFileExtension, 0                     ; which we use later
    mov ofn.lpstrDefExt, offset szBMP;         "bmp" extension
    M2M ofn.lpfnHook, offset FileSaveHookProc
    mov ofn.lpTemplateName, offset szFILESAVE

    M2M     ofn.lCustData, dwLocalOpt   ; Place our flags in the lCustData parameter
                        ; for use by "Hook" PROC
    invoke GetSaveFileName, ADDR ofn    ; Save dialog for file

    .if eax

        mov bReturn, TRUE       ;   User pressed OK, continue

;       Copy filename out

            invoke lstrcpy, pszFileName, ofn.lpstrFile

;       Copy flags out

        mov ebx, dwFlags2       ; *dwFlags = ofn.lCustData;
        mov eax, ofn.lCustData
        mov [ebx], eax

    .else

        mov bReturn, FALSE

        mov ebx, pszFileName
        mov byte ptr [ebx], 0       ; Null terminate any existing text

        mov ebx, dwFlags2
        mov dword ptr [ebx], 0      ; Clear flags in calling pgm, Why ?

    .endif

    return bReturn;
;---------------------------------------
GetFileName ENDP
;
;
;---------------------------------------
;
; GetSystemPalette
;
; Parameters:
;
; None
;
; Return Value:
;
; HPALETTE         - handle to a copy of the current system palette
;
; Description:
;
; This function returns a handle to a palette which represents the system
; palette.  The system RGB values are copied into our logical palette using
; the GetSystemPaletteEntries function.
;---------------------------------------
GetSystemPalette    PROC Pascal uses ebx
;---------------------------------------
    LOCAL hDC:HDC       ; handle to a DC
    LOCAL hLogPal:DWORD ; handle to a logical palette
    LOCAL nColors:DWORD ; number of colors
    LOCAL lpLogPal:DWORD

;   Find out how many palette entries we want.

    invoke GetDC, 0
    mov hDC, eax

    .if !hDC
        return 0
    .endif

    invoke PalEntriesOnDevice, hDC  ; Number of palette entries
    mov nColors, eax

;   Allocate room for the palette and lock it.
;   ------------------------------------------

    mov ecx, sizeof PALETTEENTRY
    mov edx, 0
    mul ecx         ; nColors * sizeof(PALETTEENTRY)

    add eax, sizeof LOGPALETTE

        invoke GlobalAlloc, GHND, eax
    mov hLogPal, eax

;   If we didn't get a logical palette, return NULL

    .if !hLogPal
        return 0
    .endif

;   Get a pointer to the logical palette

    invoke GlobalLock, hLogPal
    mov lpLogPal, eax   ; redundant - delete
    mov ebx, eax

;   Set some important fields

    mov LOGPALETTE.palVersion[ebx], PALVERSION
    M2M LOGPALETTE.palNumEntries[ebx], nColors

;   Copy the current system palette into our logical palette

    invoke GetSystemPaletteEntries, hDC, 0, nColors, LOGPALETTE.palPalEntry[ebx]

;   Go ahead and create the palette.  Once it's created,
;   we no longer need the LOGPALETTE, so free it.

    invoke CreatePalette, lpLogPal
;   mov hPal, eax
    push eax

;   Clean up

    invoke GlobalUnlock, hLogPal
    invoke GlobalFree, hLogPal
    invoke ReleaseDC, 0, hDC

    pop eax
    ret     ; Return hPal
;---------------------------------------
GetSystemPalette    ENDP
;
;
;---------------------------------------
;
; PalEntriesOnDevice
;
; Parameter:
;
; HDC hDC          - device context
;
; Return Value:
;
; int              - number of palette entries on device
;
; Description:
;
; This function gets the number of palette entries on the specified device
;
;---------------------------------------
PalEntriesOnDevice  PROC    Pascal hDC:DWORD
;---------------------------------------;
; Get number of colors on this device.  ;
;---------------------------------------;
    invoke GetDeviceCaps, hDC, BITSPIXEL
    push eax
    invoke GetDeviceCaps, hDC, PLANES
    pop ecx
    mov edx,0
    mul ecx     ; # of bits to shift now in eax

    mov ecx, eax
    mov eax, 1  ; shift this left by n bits
    shl eax, cl ; Problem if video mode is True Colour
            ; or better than 32 bits/pixel ?

;    nColors = (1 << (GetDeviceCaps(hDC, BITSPIXEL) * GetDeviceCaps(hDC, PLANES)))

    .if eax != 0
        ret     ; Return with # of palette entries
    .else
                ; Fixup if its zero value ? ###
    .endif
;---------------------------------------
PalEntriesOnDevice  ENDP
;
;
FileSaveHookProc    PROC uses ebx, hDlg:HWND, msg:DWORD, wParam:DWORD, lParam:DWORD
;---------------------------------------
    LOCAL rect:RECT,DlgRect:RECT
    LOCAL hGroup:DWORD
    LOCAL biStyle:DWORD, biBits:DWORD

    .if msg==WM_INITDIALOG

;   Get the memory handle stored in the extra words.
;   From this, insert the filename, and the file format

;   Retrieve flags which we passed in in lCustData

    mov ebx, lParam     ; Get pointer to OpenFileName struct
    mov lpofn, ebx

    M2M dwFlags, OPENFILENAME.lCustData[ebx]

;   Our dwFlags field contains the following:
;
;   HIWORD: Bits per pixel specification.  Should be set to
;           one of the following: 1, 4, 8, or 24
;
;   LOWORD: Compression specification:  Should be set to one of
;       the following:   IDD_RGB, IDD_RLE4, IDD_RLE8

    LOWORD dwFlags

    .if eax==IDD_RGB
        invoke    SendDlgItemMessage, hDlg, IDD_RGB,  BM_SETCHECK, 1, 0
            invoke    SendMessage, hDlg, WM_COMMAND, IDD_RGB, 0

    .elseif eax==IDD_RLE4
            invoke SendDlgItemMessage, hDlg, IDD_RLE4, BM_SETCHECK, 1, 0
            invoke SendMessage, hDlg, WM_COMMAND, IDD_RLE4, 0

    .else
            invoke SendDlgItemMessage, hDlg, IDD_RLE8, BM_SETCHECK, 1, 0
            invoke SendMessage, hDlg, WM_COMMAND, IDD_RLE8, 0
    .endif

    HIWORD  dwFlags
    .if eax==4
            invoke SendDlgItemMessage, hDlg, IDD_4,   BM_SETCHECK, 1, 0

    .elseif eax==8
            invoke SendDlgItemMessage, hDlg, IDD_8,   BM_SETCHECK, 1, 0

    .elseif eax==24
            invoke SendDlgItemMessage, hDlg, IDD_24,  BM_SETCHECK, 1, 0

    .else
            invoke SendDlgItemMessage, hDlg, IDD_1,   BM_SETCHECK, 1, 0

    .endif

;   Return 1 so Windows sets focus on a control in our dialog

        return 1

    .elseif msg==WM_COMMAND

        .if wParam==IDOK

        invoke SendDlgItemMessage, hDlg, IDD_RGB, BM_GETCHECK, 0, 0
        push eax
        invoke SendDlgItemMessage, hDlg, IDD_RLE4, BM_GETCHECK, 0, 0
        pop  ecx        ; recover return value from 1st of 2 above calls

            .if     ecx         ; IDD_RGB  ?
               mov  biStyle, IDD_RGB
            .elseif eax         ; IDD_RLE4 ?
               mov  biStyle, IDD_RLE4
            .else           ; Default
                mov biStyle, IDD_RLE8
        .endif

        invoke SendDlgItemMessage, hDlg, IDD_1, BM_GETCHECK, 0, 0
        push eax
        invoke SendDlgItemMessage, hDlg, IDD_4, BM_GETCHECK, 0, 0
        push eax
        invoke SendDlgItemMessage, hDlg, IDD_8, BM_GETCHECK, 0, 0

        pop  edx        ; Recover value from 2nd of above 3 calls
        pop  ecx        ; Recover value from 1st of above 3 calls

            .if ecx     ; IDD_1 ?
               mov biBits, 1
            .elseif edx     ; IDD_4 ?
               mov biBits, 4
            .elseif eax     ; IDD_8 ?
               mov biBits, 8
            .else       ; Default
               mov biBits, 24
        .endif

;   Copy result of user input to our lCustData field, which
;   will pass it back to the calling function.

        xor eax,eax
        mov eax, biStyle
        shl ax,16       ; Move to high word
        or  eax, biBits ; Set low word
        mov ebx, lpofn  ; Reload pointer in reg
        mov OPENFILENAME.lCustData[ebx], eax

        .elseif wParam==IDD_FILETYPE

        invoke GetDlgItem, hDlg, IDD_FILETYPEGROUP
            mov hGroup, eax
            invoke GetWindowRect, hGroup, ADDR rect
            invoke GetWindowRect, hDlg, ADDR DlgRect

        mov eax, DlgRect.right
        sub eax, DlgRect.left   ; (DlgRect.right-DlgRect.left)
        mov ecx, rect.bottom
        add ecx, rect.left
        sub ecx, DlgRect.left
        sub ecx, DlgRect.top ; (rect.bottom+(rect.left-DlgRect.left)-DlgRect.top)

            invoke SetWindowPos, hDlg,0, DlgRect.left, DlgRect.top, \
                                 eax, ecx, SWP_NOMOVE or SWP_NOZORDER
        invoke GetDlgItem, hDlg, IDD_FILETYPE
            invoke EnableWindow, eax, 0
            invoke SetFocus, hGroup

    .elseif wParam==IDD_RLE4

        invoke SendDlgItemMessage, hDlg, IDD_1, BM_GETCHECK, 0, 0     ; Is it checked
            .if eax
        invoke  SendDlgItemMessage, hDlg, IDD_1, BM_SETCHECK, 0,0
        .endif

        invoke SendDlgItemMessage, hDlg, IDD_8, BM_GETCHECK, 0, 0
            .if eax
                invoke SendDlgItemMessage, hDlg, IDD_8, BM_SETCHECK, 0,0
        .endif
        invoke SendDlgItemMessage, hDlg, IDD_24, BM_GETCHECK, 0, 0
            .if eax
                invoke SendDlgItemMessage, hDlg, IDD_24, BM_SETCHECK, 0,0
        .endif

        invoke GetDlgItem, hDlg, IDD_4
            invoke EnableWindow, eax, 1

            invoke SendDlgItemMessage, hDlg, IDD_4, BM_SETCHECK, 1, 0

        invoke GetDlgItem, hDlg, IDD_1
            invoke EnableWindow, eax, 0
        invoke GetDlgItem, hDlg, IDD_8
            invoke EnableWindow, eax, 0
        invoke GetDlgItem, hDlg, IDD_24
            invoke EnableWindow, eax, 0

    .elseif wParam==IDD_RLE8

        invoke SendDlgItemMessage, hDlg, IDD_1, BM_GETCHECK, 0, 0
            .if eax
                invoke SendDlgItemMessage, hDlg, IDD_1, BM_SETCHECK, 0,0
        .endif

         invoke SendDlgItemMessage, hDlg, IDD_4, BM_GETCHECK, 0, 0
            .if eax
                invoke SendDlgItemMessage, hDlg, IDD_4, BM_SETCHECK, 0,0
        .endif

        invoke SendDlgItemMessage, hDlg, IDD_24, BM_GETCHECK, 0, 0
            .if eax
                invoke SendDlgItemMessage, hDlg, IDD_24, BM_SETCHECK, 0,0
        .endif

        invoke GetDlgItem, hDlg, IDD_8
            invoke EnableWindow, eax, 1
            invoke SendDlgItemMessage, hDlg, IDD_8, BM_SETCHECK, 1, 0
        invoke GetDlgItem, hDlg, IDD_1
            invoke EnableWindow, eax, 0
        invoke GetDlgItem, hDlg, IDD_4
            invoke EnableWindow, eax, 0
        invoke GetDlgItem, hDlg, IDD_24
            invoke EnableWindow, eax, 0

    .elseif wParam==IDD_RGB

        invoke GetDlgItem, hDlg, IDD_1
            invoke EnableWindow, eax, 1
        invoke GetDlgItem, hDlg, IDD_4
            invoke EnableWindow, eax, 2
        invoke GetDlgItem, hDlg, IDD_8
            invoke EnableWindow, eax, 3
        invoke GetDlgItem, hDlg, IDD_24
            invoke EnableWindow, eax, 1

        .endif

    .endif

    return FALSE
;---------------------------------------
FileSaveHookProc    ENDP
;
;
;---------------------------------------
;
; PaletteSize
;
; Parameter:
;
; LPSTR lpDIB      - pointer to packed-DIB memory block
;
; Return Value:
;
; DWORD             - size of the color palette of the DIB
;
; Description:
;
; This function gets the size required to store the DIB's palette by
; multiplying the number of colors by the size of an RGBQUAD (for a
; Windows 3.0-style DIB) or by the size of an RGBTRIPLE (for an OS/2-
; style DIB).
;
;---------------------------------------
PaletteSize PROC Pascal lpDIB:DWORD ; lpDIB points to the DIB
;---------------------------------------
    mov eax, lpDIB

;   Calculate the size required by the palette

        mov eax, [eax]
        .if eax==sizeof BITMAPINFOHEADER

            invoke DIBNumColors, lpDIB
            mov ecx, sizeof RGBQUAD
            mul ecx         ; eax=DIBNumColors(lpDIB) * sizeof(RGBQUAD)
        .else
        invoke DIBNumColors, lpDIB
        mov ecx, sizeof RGBTRIPLE
        mul ecx
        .endif
    ret             ; eax holds size of colour palette
;---------------------------------------
PaletteSize ENDP
;
;
;---------------------------------------
;
; DIBNumColors
;
; Parameter:
;
; LPSTR lpDIB      - pointer to packed-DIB memory block
;
; Return Value:
;
; DWORD             - number of colors in the color table
;
; Description:
;
; This function calculates the number of colors in the DIB's color table
; by finding the bits per pixel for the DIB
; If bits per pixel is 1: colors=2, if 4: colors=16, if 8: colors=256,
; if 24, no colors in color table.
;
;---------------------------------------
DIBNumColors    PROC Pascal uses ebx, lpDIB:DWORD
;---------------------------------------
    LOCAL bmitype:DWORD

    mov bmitype, FALSE

;   If this is a Windows-style DIB, the number of colors in the
;   color table can be less than the number of bits per pixel
;   allows for (i.e. lpbi->biClrUsed can be set to some value).
;   If this is the case, return the appropriate value.

    mov ebx, lpDIB          ; Points to the DIB

    mov eax, [ebx]

    .if eax== sizeof BITMAPINFOHEADER
        mov bmitype, TRUE
        mov eax, BITMAPINFOHEADER.biClrUsed[ebx]    ; Get colours used

        .if eax
        ret
        .endif
    .endif

;   Calculate the number of colors in the color table based on
;   the number of bits per pixel for the DIB.

    .if bmitype
        mov ax, BITMAPINFOHEADER.biBitCount[ebx]
    .else
        mov ax, BITMAPCOREHEADER.bcBitCount[ebx]
    .endif

;   Return number of colors based on bits per pixel

    .if ax==1
        return 2
    .elseif ax==4
        return 16
    .elseif ax==8
        return 256
    .else       ; default and we seem to use it !

;   What about high color modes such as TRUE Colour 20 bits and over ?

        return 0
    .endif
;---------------------------------------
DIBNumColors    ENDP
;
;
;---------------------------------------
;
; SaveDIB
;
; Saves the specified DIB into the specified file name on disk.  No
; error checking is done, so if the file already exists, it will be
; written over.
;
; Parameters:
;
; HDIB hDib - Handle to the dib to save
;
; LPSTR lpFileName - pointer to full pathname to save DIB under
;
; Return value: 0 if successful, or one of:
;        ERR_INVALIDHANDLE
;        ERR_OPEN
;        ERR_LOCK
;---------------------------------------
SaveDIB     PROC Pascal uses ebx, hDib:DWORD, lpFileName:DWORD
;---------------------------------------
    LOCAL bmfHdr:BITMAPFILEHEADER   ; Header for Bitmap file
    LOCAL lpBI:DWORD        ; Pointer to DIB info structure
    LOCAL fh:DWORD          ; File handle
    LOCAL dwDIBSize:DWORD, dwWritten:DWORD
        LOCAL dwBmBitsSize:DWORD    ; Size of Bitmap Bits only

    .if !hDib
            return FALSE    ; ERR_INVALIDHANDLE
    .endif

    invoke CreateFile, lpFileName, GENERIC_WRITE, 0, 0, CREATE_ALWAYS, \
            FILE_ATTRIBUTE_NORMAL or FILE_FLAG_SEQUENTIAL_SCAN, 0
    mov fh, eax

    .if fh==INVALID_HANDLE_VALUE
            return FALSE    ;  ERR_OPEN
    .endif

;   Get a pointer to the DIB memory, the first of which contains
;   a BITMAPINFO structure

    invoke GlobalLock, hDib     ; Returns pointer to BITMAPINFOHEADER
    mov lpBI, eax
    mov ebx, eax

    .if !eax
            invoke CloseHandle, fh
            return FALSE    ; ERR_LOCK
    .endif

;   Check to see if we're dealing with an OS/2 DIB. If so, don't save
;   it because our functions aren't written to deal with these DIBs

    .if BITMAPINFOHEADER.biSize[ebx] != sizeof BITMAPINFOHEADER
        invoke GlobalUnlock, hDib
            invoke CloseHandle, fh
        return FALSE    ; ERR_NOT_DIB
    .endif

;   Fill in the fields of the file header

;   Fill in file type (first 2 bytes must be "BM" for a bitmap)

    mov  bmfHdr.bfType, 04D42h  ; "BM"

;   Calculating the size of the DIB is a bit tricky (if we want to
;   do it right).  The easiest way to do this is to call GlobalSize()
;   on our global handle, but since the size of our global memory may have
;   been padded a few bytes, we may end up writing out a few too
;   many bytes to the file (which may cause problems with some apps,
;   like HC 3.0).

;   So, instead let's calculate the size manually.
;   To do this, find size of header plus size of color table.  Since the
;   first DWORD in both BITMAPINFOHEADER and BITMAPCOREHEADER conains
;   the size of the structure, let's use this.

;   Partial Calculation

    invoke PaletteSize, ebx

    mov ecx, [ebx]
    add eax, ecx
    mov dwDIBSize, eax  ;*(LPDWORD)lpBI + PaletteSize((LPSTR)lpBI)

;   Now calculate the size of the image

;   It's an RLE bitmap, we can't calculate size, so trust the biSizeImage
;       field

    .if BITMAPINFOHEADER.biCompression[ebx]==BI_RLE8 \
         || BITMAPINFOHEADER.biCompression[ebx]==BI_RLE4

         mov eax, BITMAPINFOHEADER.biSizeImage[ebx]
             add dwDIBSize, eax
    .else

;   It's not RLE, so size is Width (DWORD aligned) * Height

        mov ecx,0
        mov edx,0
        mov eax, BITMAPINFOHEADER.biWidth[ebx]
        mov cx,  BITMAPINFOHEADER.biBitCount[ebx]
        mul ecx
        mov ecx, BITMAPINFOHEADER.biHeight[ebx]
        mul ecx

        WIDTHBYTES eax
        mov dwBmBitsSize, eax
        add dwDIBSize, eax

;   Now, since we have calculated the correct size, why don't we
;   fill in the biSizeImage field (this will fix any .BMP files which
;   have this field incorrect).

        M2M   BITMAPINFOHEADER.biSizeImage[ebx], dwBmBitsSize

    .endif

;   Calculate the file size by adding the DIB size to sizeof(BITMAPFILEHEADER)

    mov eax, dwDIBSize
    add eax, sizeof BITMAPFILEHEADER
    mov bmfHdr.bfSize, eax
    mov bmfHdr.bfReserved1, 0
    mov bmfHdr.bfReserved2, 0

;   Now, calculate the offset the actual bitmap bits will be in
;   the file -- It's the Bitmap file header plus the DIB header,
;   plus the size of the color table.

    invoke PaletteSize, ebx
    add eax, sizeof BITMAPFILEHEADER
    add eax, BITMAPINFOHEADER.biSize[ebx]

    mov bmfHdr.bfOffBits, eax ; Sizeof BITMAPFILEHEADER + lpBI->biSize + PaletteSize((LPSTR)lpBI

;   Write the file header

    invoke WriteFile, fh, ADDR bmfHdr, sizeof BITMAPFILEHEADER, ADDR dwWritten,0

;   Write the DIB header and the bits -- use local version of
;   MyWrite, so we can write more than 32767 bytes of data

    invoke WriteFile, fh, ebx, dwDIBSize, ADDR dwWritten, 0

    invoke GlobalUnlock,hDib
    invoke CloseHandle, fh

    .if dwWritten==0
            return FALSE    ; ERR_OPEN  ; oops, something happened in the write
    .else
        return TRUE     ; Success code
    .endif
;---------------------------------------
SaveDIB     ENDP
;
;
;---------------------------------------
;
; PaintBitmap
;
; Parameters:
;
; HDC hDC          - DC to do output to
;
; LPRECT lpDCRect  - rectangle on DC to do output to
;
; HBITMAP hDDB     - handle to device-dependent bitmap (DDB)
;
; LPRECT lpDDBRect - rectangle of DDB to output into lpDCRect
;
; HPALETTE hPalette - handle to the palette to use with hDDB
;
; Return Value:
;
; BOOL             - TRUE if bitmap was drawn, FLASE otherwise
;
; Description:
;
; Painting routine for a DDB.  Calls BitBlt or
; StretchBlt to paint the DDB.  The DDB is
; output to the specified DC, at the coordinates given
; in lpDCRect.  The area of the DDB to be output is
; given by lpDDBRect.  The specified palette is used.
;
; NOTE: This function always selects the palette as background. Before
; calling this function, be sure your palette is selected to desired
; priority (foreground or background).
;
;---------------------------------------
PaintBitmap PROC    Pascal uses ebx esi, hDC:HDC, lpDCRect:DWORD, \
                    hDDB:DWORD, lpDDBRect:DWORD, hPal2:DWORD
;---------------------------------------
    LOCAL hMemDC:DWORD  ; Handle to memory DC
    LOCAL hOldBitmap:DWORD  ; Handle to previous bitmap
    LOCAL hOldPal1:DWORD    ; Handle to previous palette
    LOCAL hOldPal2:DWORD    ; Handle to previous palette
    LOCAL bSuccess:DWORD    ; Success/fail flag
    LOCAL DCRwidth:DWORD, DCRheight:DWORD, DDBRwidth:DWORD,DDBRheight:DWORD

    mov hOldPal1, 0     ; Initialise
    mov hOldPal2, 0     ;
    mov bSuccess, 0     ;

    mov ebx, lpDCRect   ; Get pointers to rectangle
    mov esi, lpDDBRect  ;

    invoke CreateCompatibleDC, hDC  ; Create a memory DC
    mov hMemDC, eax

;   If this failed, return FALSE

    .if !hMemDC
        return FALSE
    .endif

;   If we have a palette, select and realize it

    .if hPal2
        invoke SelectPalette, hMemDC, hPal2, TRUE
        mov hOldPal1, eax
        invoke SelectPalette, hDC, hPal2, TRUE
        mov hOldPal2, eax
        invoke RealizePalette, hDC
    .endif

    invoke SelectObject, hMemDC, hDDB   ; Select bitmap into the memory DC
    mov hOldBitmap, eax

;   Make sure to use the stretching mode best for color pictures

    invoke SetStretchBltMode, hDC, COLORONCOLOR

;   Determine whether to call StretchBlt or BitBlt

    mov eax, RECT.right[ebx]
    sub eax, RECT.left[ebx]
    mov DCRwidth, eax       ; Got DC rect width
    mov eax, RECT.right[esi]
    sub eax, RECT.left[esi]
    mov DDBRwidth, eax      ; Got DDB rect width

    mov eax, RECT.bottom[ebx]
    sub eax, RECT.top[ebx]
    mov DCRheight, eax      ; Got DC rect height
    mov eax, RECT.bottom[esi]
    sub eax, RECT.top[esi]
    mov DDBRheight, eax     ; Got DDB rect height

    mov eax, DCRwidth
    mov ecx, DCRheight

    .if eax == DDBRwidth && ecx == DDBRheight

        invoke BitBlt, hDC, RECT.left[ebx], RECT.top[ebx], \
                           DCRwidth, DCRheight, hMemDC,        \
                           RECT.left[esi], RECT.top[esi], SRCCOPY
    .else
        invoke StretchBlt, hDC, RECT.left[ebx], RECT.top[ebx], \
                               DCRwidth, DCRheight, hMemDC, \
                            RECT.left[esi], RECT.top[esi],  \
                            DDBRwidth,DDBRheight, SRCCOPY
    .endif
        mov bSuccess, eax

    invoke SelectObject, hMemDC, hOldBitmap

    .if hOldPal1
        invoke SelectPalette, hMemDC, hOldPal1, FALSE
    .endif

    .if hOldPal2
        invoke SelectPalette, hDC, hOldPal2, FALSE
    .endif

    invoke DeleteDC, hMemDC

    return bSuccess     ; Return with success/fail flag
;---------------------------------------
PaintBitmap ENDP
;
;
        end     Start

